package fi.helsinki.cs.seco.onki.config;

import com.hp.hpl.jena.rdf.model.RDFList;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.util.iterator.ExtendedIterator;
import com.hp.hpl.jena.vocabulary.*;

import java.util.LinkedList;
import java.util.List;

public class ServiceConfiguration extends Configuration {

	
	public List<ServiceConfiguration> getServices() { 
		RDFNode servicesNode = this.getProperty("services");
		List<RDFNode> nodelist = ((RDFList)servicesNode.as(RDFList.class)).asJavaList();
		List<ServiceConfiguration> reslist = new LinkedList<ServiceConfiguration>();
		
		for(RDFNode node: nodelist) {
			if (((Resource)node).equals(this.onkiConfig.getOnkiConfResource("allActiveOntologyServices"))) {
				StmtIterator stmtI = this.onkiConfig.getModel().listStatements(null, RDF.type, this.onkiConfig.getOnkiConfResource("OntologyService"));
				while (stmtI.hasNext()) {
					OntologyServiceConfiguration osc = (OntologyServiceConfiguration)this.onkiConfig.createServiceConfiguration(stmtI.nextStatement().getSubject(), this);
					if (osc.getIsActive())
						reslist.add(osc);
				}
			} else {
				ServiceConfiguration sc = this.onkiConfig.createServiceConfiguration((Resource)node, this);
				if (sc != null)
					reslist.add(sc);
			}
		}
		return reslist;	
	}
}
