package fi.helsinki.cs.seco.onki.index;

/**
 * Represents metadata about a query in the alphabetical index.
 */

public class IndexResultsMetadata {
	
	private int totalHits;
	private int containingHits;
	
	public IndexResultsMetadata(int totalHits, int containingHits) {
		this.totalHits = totalHits;
		this.containingHits = containingHits;
	}
	
    /**
	 * Get the total number of hits matching the query.
	 */
	
	public int getTotalHitsAmount() {
		return this.totalHits;
	}
	
    /**
	 * Get the number of hits in the current result set.
	 */
	
	public int getContainingHitsAmount() {
		return this.containingHits;
	}
	
    /**
	 * Get the number of hits that did not fit into the current result set.
	 */
	
	public int getMoreHitsAmount() {
		return this.getTotalHitsAmount() - this.getContainingHitsAmount();
	}
	
    /**
	 * Is there more hits than the ones in the current result set. 
	 */
	
	public boolean isMoreHits() {
		return this.getMoreHitsAmount() > 0;
	}
}