package fi.helsinki.cs.seco.onki.logic.propertyfiddlers;

import java.util.List;
import java.util.LinkedList;

import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.ResourceFactory;

import fi.helsinki.cs.seco.onki.logic.IPropertyFiddler;
import fi.helsinki.cs.seco.onki.logic.OnkiResource;
import fi.helsinki.cs.seco.onki.logic.OnkiStatement;

/**
 * Generate relations from YSA terms to YSO concepts in YSO.
 */

public class YsaTermYsoConceptPropertyFiddler implements IPropertyFiddler {
	
	private static final String NS_OM = "http://www.yso.fi/onto/yso/peilaus/2007-03-02/";
	private static final Property OM_definedConcept = ResourceFactory.createProperty(NS_OM+"definedConcept");

	/** 
	 * Find backward relation to YSO Concept.
	 */
	
	public List<OnkiStatement> findBackward(OnkiResource ores) {
		if (!ores.getResource().isResource())
			return null;
		
		StmtIterator stmti = ores.getResource().getModel().listStatements(null, OM_definedConcept, ores.getResource());
		if (!stmti.hasNext())
			return null;

		List<OnkiStatement> reslist = new LinkedList<OnkiStatement>();
		reslist.add(new OnkiStatement(ores, OM_definedConcept, stmti.nextStatement().getSubject(), ores.getLangPreferences(), OnkiStatement.TYPE_INVERSE));
		return reslist;
	}

	// not needed currently
	public List<OnkiStatement> findForward(OnkiResource ores, Statement stmt) {
		return null;
	}
}