package fi.helsinki.cs.seco.onki.service;

import java.io.Serializable;
import java.util.Collection;
import java.util.Collections;
import java.util.LinkedList;

/**
 * Represents a directory of the ontology
 * Directory may be 1) an alphabetical index.
 * 2) based on concept groups or 3) based on top concepts (SKOS).
 */

public class OnkiDirectory implements Serializable {

	private static final long serialVersionUID = 1L;
	
	private String type;
	private String lang;
	private LinkedList<OnkiDirectoryElement> elements;
	
	public OnkiDirectory() {
		this.elements = new LinkedList<OnkiDirectoryElement>();
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getLang() {
		return lang;
	}

	public void setLang(String lang) {
		this.lang = lang;
	}

	public Collection<OnkiDirectoryElement> getElements() {
		return elements;
	}
	
	public void addElement(OnkiDirectoryElement element) {
		this.elements.add(element);
	}

	public int getSize() {
		return this.elements.size();
	}

	public boolean isEmpty() {
		return this.elements.isEmpty();
	}
	
	public void sort() {
		Collections.sort(this.elements);
	}
}