package fi.helsinki.cs.seco.onki.service;

/**
 * Represents a relation in the concept hierarchy.
 */

public class OnkiHierarchyRelation {
	private String conceptUri;
	private String parentUri;
	private String label;
	private int indent;
	
	public OnkiHierarchyRelation(String conceptUri, String parentUri, String label, int indent) {
		this.conceptUri = conceptUri;
		this.parentUri = parentUri;
		this.label = label;
		this.indent = indent;
	}
	
	public String getConceptUri() {
		return this.conceptUri;
	}
	
	public String getParentUri() {
		return this.parentUri;
	}
	
	public String getLabel() {
		return this.label;
	}
	
	public int getIndent() {
		return this.indent;
	}

	public boolean equals(Object arg) {
		return (arg instanceof OnkiHierarchyRelation &&
				((this.getParentUri() == null && ((OnkiHierarchyRelation)arg).getParentUri() == null) ||
				(this.getParentUri() != null &&
				((OnkiHierarchyRelation)arg).getParentUri() != null &&
				this.getConceptUri().equals(((OnkiHierarchyRelation)arg).getConceptUri()) &&
				this.getParentUri().equals(((OnkiHierarchyRelation)arg).getParentUri()))));
	}
	
	//TODO: implement public int hashCode() - see OnkiStatement for example
}