package fi.helsinki.cs.seco.onki.servlet;

import java.util.Collection;

import org.json.JSONArray;
import org.restlet.Context;  
import org.restlet.data.MediaType;  
import org.restlet.data.Request;  
import org.restlet.data.Response;  
import org.restlet.ext.json.JsonRepresentation;
import org.restlet.resource.Representation;  
import org.restlet.resource.ResourceException;  
import org.restlet.resource.Variant;

/**
 * Represents languages of labels the concept index contains.
 */

public class GetAvailableLanguagesResource extends BaseResource {
	Collection<String> languages;
	
	public GetAvailableLanguagesResource(Context context, Request request, Response response) {  
		super(context, request, response);  
			   
		this.languages = getAvailableLanguages();
		
		getVariants().add(new Variant(MediaType.APPLICATION_JSON));
	}
	
	/** 
	 * Returns a full representation for a given variant. 
	 */  
	@Override  
	public Representation represent(Variant variant) throws ResourceException {  
		JSONArray array = new JSONArray();
		if (this.languages != null) {
			for (String language : this.languages)
				array.put(language);
		}

		JsonRepresentation representation = new JsonRepresentation(array);
		representation.setModificationDate(getLastModified());
		representation.setExpirationDate(getExpires());
		this.finalize();
	    return representation;
	}
}