package fi.helsinki.cs.seco.onki.servlet;

import org.restlet.Context;  
import org.restlet.data.CharacterSet;
import org.restlet.data.Form;
import org.restlet.data.MediaType;  
import org.restlet.data.Parameter;
import org.restlet.data.Request;  
import org.restlet.data.Response;  
import org.restlet.resource.Representation;  
import org.restlet.resource.ResourceException;  
import org.restlet.resource.StringRepresentation;
import org.restlet.resource.Variant;  

/**
 * Represents properties of a concept as RDF.
 */

public class GetPropertiesAsRdfResource extends BaseResource {
	String uri;
	String rdf = "";
	
	public GetPropertiesAsRdfResource(Context context, Request request, Response response) {  
		super(context, request, response);  
			   
		Form query = getRequest().getResourceRef().getQueryAsForm();
		 
		for (Parameter param : query) {
			if (param.getName().equals("u"))
				this.uri = param.getValue();
		}
		 
		if (this.uri != null)
			this.rdf = getPropertiesAsRdf(this.uri);

		getVariants().add(new Variant(MediaType.APPLICATION_RDF_XML));
	}
	
	/** 
	 * Returns a full representation for a given variant. 
	 */  
	@Override  
	public Representation represent(Variant variant) throws ResourceException {		
		StringRepresentation representation = new StringRepresentation(null);
		representation.setCharacterSet(CharacterSet.UTF_8);
		representation.setText(this.rdf);
		
		representation.setMediaType(MediaType.APPLICATION_RDF_XML);
		
		representation.setModificationDate(getLastModified());
		representation.setExpirationDate(getExpires());
		this.finalize();
	    return representation;
	}
}