package fi.helsinki.cs.seco.onki.stats;

/**
 * A container for ontology statistics.
 * 
 * @author vpkomula
 */

public class OnkiNsStat implements Comparable {

    ////////////////////////////////////////////////////////////
    //	Private variables
    ////////////////////////////////////////////////////////////
	
    private String nsUri;
    private String nsPrefix;
    
    private int classCount;
    private int individualCount;
    private int statementCount;
    private int propertyCount;
    
    ////////////////////////////////////////////////////////////
    //	Constructors
    ////////////////////////////////////////////////////////////
    
    /**
     * @param nsUri
     * @param nsPrefix
     */
    public OnkiNsStat(String nsUri, String nsPrefix) {
        
        this.nsUri = nsUri;
        this.nsPrefix = nsPrefix;
    }
    
    /**
     * @param nsUri
     * @param nsPrefix
     * @param classCount
     * @param individualCount
     * @param statementCount
     * @param propertyCount
     */
    public OnkiNsStat(String nsUri, String nsPrefix, int classCount,
            int individualCount, int statementCount, int propertyCount) {
        this.nsUri = nsUri;
        this.nsPrefix = nsPrefix;
        this.classCount = classCount;
        this.individualCount = individualCount;
        this.statementCount = statementCount;
        this.propertyCount = propertyCount;
    }
    
    ////////////////////////////////////////////////////////////
    //	Getters, Setters
    ////////////////////////////////////////////////////////////
    
    public int getClassCount() {
        return classCount;
    }
    
    public void setClassCount(int classCount) {
        this.classCount = classCount;
    }
    
    public int getIndividualCount() {
        return individualCount;
    }
    
    public void setIndividualCount(int individualCount) {
        this.individualCount = individualCount;
    }
    
    public String getNsPrefix() {
    	/*        if (nsPrefix == null || nsPrefix.equals("")) {
            nsPrefix = (String) OntologyProcessor.getAdditionalPrefixes().get(nsUri);
            if (nsPrefix == null) {
                nsPrefix = "";
            }
        }*/
    	if (this.nsPrefix == null)
            this.nsPrefix = "";
        return this.nsPrefix;
    }
    
    public void setNsPrefix(String nsPrefix) {
        this.nsPrefix = nsPrefix;
    }
    
    public String getNsUri() {
        return nsUri;
    }
    
    public void setNsUri(String nsUri) {
        this.nsUri = nsUri;
    }
    
    public int getPropertyCount() {
        return propertyCount;
    }
    
    public void setPropertyCount(int propertyCount) {
        this.propertyCount = propertyCount;
    }
    
    public int getStatementCount() {
        return statementCount;
    }
    
    public void setStatementCount(int statementCount) {
        this.statementCount = statementCount;
    }
    
    public String toString() {
        return nsPrefix + ":" + nsUri + 
        				  " [stmt:" + statementCount + 
        				  ",class:" + classCount + 
        				  ",indiv:" + individualCount + 
        				  ",prop:" + propertyCount + "]"; 
    }
    
    public int compareTo(Object arg0) {
        int result = 1;
        if (arg0 != null && arg0 instanceof OnkiNsStat) {
            OnkiNsStat argStat = (OnkiNsStat) arg0;
            String argPrefix = argStat.getNsPrefix();
            
            if (argPrefix != null && this.nsPrefix != null) {
                result = this.nsPrefix.compareTo(argPrefix);
            } else if (argPrefix != null && this.nsPrefix == null) {
                result = -1;
            } else { 
                result = 1;
            }
        }
        return result;
    }
}