<!-- $Id: anno-howto.jsp,v 1.0 2005/05/16 10:28:42 vpkomula Exp $ -->
<table class="anno-content" border="0" width="100%" align="center" cellpadding="0" cellspacing="0">
<!-- Description -->
<tr class="header-title">
	<td class="anno-title">&nbsp;1. How-to</td>
</tr>
<tr>
	<td class="anno-text">
	<ul type="square">
		<li>Currently there are 3 different ways to hook-up your application to Onki. However, solutions 1 and 2 have 
		some restrictions depending on your browser or your domain.
		<ol>
			<li>SOAP-interface, for all applications</li>
			<li>XMLHttprequest-API or HTTP-API, for web-apps viewed with modern browsers</li>
			<li>Javascript-API, for web-apps viewed with modern browsers</li>
		</ol>
		</li>
		<li>The restrictions in XMLHttprequest and javascript-API arise from browsers cross-site scripting vulnerability. One can not
		reference from domain1 to domain2 with these techniques without some hacking. Table below illustrates this and the hacks to bypass
		this are explained in detail in section 2, Examples.</li>
		<li>Restrictions table:</li>
	</ul>
	<table align="center" class="catalog" cellpadding="1" cellspacing="0">
	<tr bgcolor="#CCCCCC">
		<td>&nbsp;</td><td  class="centered" width="200">Same domain</td><td class="centered" width="200">Different domain</td><td  class="centered"  width="280">Different domain + bypass proxy</td>
	</tr>
	<tr>
		<td class="centered">Pop-up window</td><td class="centered">IE && FF</td><td class="centered">-</td><td class="centered">IE & FF **</td>
	</tr>
	<tr>
		<td class="centered">XMLHttpRequest</td><td class="centered">IE && FF</td><td class="centered">IE*</td><td class="centered">IE & FF **</td>
	</tr>
	<tr>
		<td class="centered">SOAP</td><td class="centered">XML</td><td class="centered">XML</td><td class="centered">XML</td>
	</tr>
	</table>
	<ul type="square">
		<li><b>FF</b> : Firefox</li>
		<li><b>IE</b> : Internet Explorer</li>
		<li><b>IE*</b> : MS Interner Explorer users can use XMLhttpRequest cross-site by adjusting browser settings.
			<ol>
				<li>Open Menu 'Tools / Internet Options'</li>
				<li>From 'Security'-tab select 'Trusted Sites' from the Zones icons and click 'sites...'.</li>
				<li>Add ONKI-Browser server-url to this list. For example http://db.cs.helsinki.fi/</li>
			</ol>
			</li>
		<li><b>IE & FF**</b> : These features can be used by providing 'bypass proxy'-mechanism using utilities such as Apache HTTP-servers <a href="http://httpd.apache.org/docs/1.3/mod/mod_rewrite.html">mod_rewrite</a>, or for MS IIS-servers <a href="http://www.isapirewrite.com/">ISAPI_Rewrite Lite</a> might do the work.</li>
		<li><b>Bypass proxy</b> : <a href="http://www.livejournal.com/users/premshree/66129.html">Mechanism</a> for proxying the request so through local url which forwards the query to another url</li>
		<li><b>XML</b> : Connecting by SOAP is naturally possible from all application, but developers need to build their own UI</li>
	</ul>
	</br>
	
	</td>
</tr>
<tr class="header-title">
	<td class="anno-title">&nbsp;2. Examples</td>
</tr>
<tr>
	<td class="anno-text">
	<ol type="square">
		<li>Javascript API, Same domain</li>
		<ol>
			<li></li>
		</ol>
		</br>
		<li>XMLHttpRequest, Same domain</li>
		<ol>
			<li></li>
		</ol>
		</br>
		<li>XMLHttpRequest, Different domain: using IE</li>
			<ol>
				<li>Just as in same domain, but set the security zones as advised in how-to.</li>
			</ol>
		</br>
		<li>Javascript API, XMLHttpRequest : Different Domain
			<ol>
				<li>Configure your proxying extension.</li>
			</ol>
		</li>
		</br>
		<li>SOAP-interface</li>
			<ol>
				<li>Query concepts with the provided SOAP-methods. WSDL for these can be found from <a href="http://db.cs.helsinki.fi/tomcat/vpkomula/onki/services/">here</a>.</li>
			</ol>
		</br>
	</ol>
	</td>
</tr>
</table>