// ONKI Mash-Up component main Javascript file for loading needed JS and CSS files
// Jouni Tuominen, 23.7.2007

// Include needed stylesheet and scripts

var host;
var ysourl;
var accesskey = "";
var UILang;
var publicOnki = false;
var onkilogger = null;
//var onkilogger = "http://www.seco.tkk.fi/u/jwtuomin/svn/secoweb/www.yso.fi/log/widgetlogger.php?s=1263904438.5949&d=";

function loadOnkiScripts() {
	//Check whether onki.js is loaded from public onki (www.yso.fi) or not
	var scriptList = document.getElementsByTagName("script");
	
	for (var i=0; i<scriptList.length; ++i) {
		var value = scriptList[i].getAttribute("src");
		if (value && value.match(/onki.js/)) {
			if (value.match(/http:\/\/www.yso.fi\/onki.js/)) {
				host = "http://www.yso.fi/";
				publicOnki = true;
			}
			else if (value.match(/https:\/\/www.yso.fi\/onki.js/)) {
				host = "https://www.yso.fi/";
				ysourl = "https://www.yso.fi";
				publicOnki = true;
			}			
			else
				host = value.substring(0, value.indexOf("scripts/onki.js"));
			if (value.indexOf("?") != -1) {
				if (value.indexOf("&") == -1) {
					if (value.indexOf("=") == -1)
						accesskey = "/key-" + value.substring(value.indexOf("?")+1);
					// get UI lang
					else if (value.indexOf("?l=") != 1)
						UILang = value.substring(value.indexOf("?l=")+3);
				}
				else {
					var temp = value.substring(value.indexOf("?")+1, value.indexOf("&")); 
					if (temp.indexOf("=") == -1)
						accesskey = "/key-" + temp;
					// get UI lang
					if (value.indexOf("&l=") != -1) {
						if (value.indexOf("&", value.indexOf("&l=")+1) != 1)
							UILang = value.substring(value.indexOf("&l=")+3);
						else
							UILang = value.substring(value.indexOf("&l=")+3, value.indexOf("&", value.indexOf("&l=")+1));
					}
				}				
			}
			if (ysourl == undefined)
				ysourl = "http://www.yso.fi";
			ysourl += accesskey;
		}
	}
	
	var headTag = document.getElementsByTagName("head")[0];
	
	var linkElement = document.createElement("link");
	linkElement.setAttribute("rel", "stylesheet");
	linkElement.setAttribute("type", "text/css");
	linkElement.setAttribute("href", host+"css/autocomplete.css");
	headTag.insertBefore(linkElement, headTag.firstChild);

	var scripts = new Array(host+"scripts/engine.js", host+"scripts/OnkiBrowser.js",
	host+"scripts/ConceptCollector.js", host+"scripts/OnkiFinder.js",
	host+"scripts/OnkiSearch.js", host+"scripts/CreateOnki.js");


/*
importJS("http://yui.yahooapis.com/2.6.0/build/yahoo/yahoo-min.js", 'YAHOO', function() {
	importJS("http://yui.yahooapis.com/2.6.0/build/get/get-min.js", 'YAHOO.util.Get', function() {
		YAHOO.util.Get.script(scripts, {timeout: 5000, onTimeout: function(o) {
			o.purge();
		}
		});
	});
});


function importJS(src, look_for, onload) {
    var s = document.createElement('script');
    s.setAttribute('type', 'text/javascript');
    s.setAttribute('src', src);
    if (onload) wait_for_script_load(look_for, onload);
    var head = document.getElementsByTagName('head')[0];
    if (head) {
      head.appendChild(s);
    } else {
      document.body.appendChild(s);
    }
}

function wait_for_script_load(look_for, callback) {
    var interval = setInterval(function() {
      if (eval("typeof " + look_for) != 'undefined') {
        clearInterval(interval);
        callback();
      }
    }, 50);
}
*/

	
/*
var scriptLoaded = false;
	
var script = host+"app/scripts/OnkiBrowser.js";
var scriptElement = document.createElement("script");
scriptElement.setAttribute("src", script);
scriptElement.setAttribute("type", "text/Javascript");
scriptElement.onload = function() {
	scriptLoaded = true;
};
headTag.appendChild(scriptElement);
	
var intervalID = window.setInterval(checkScriptLoaded, 5000);

function checkScriptLoaded() {

	if (scriptLoaded)
		alert("script is loaded :(");
	
	if (!scriptLoaded) {
		alert("abort script loading.");
		//headTag.removeChild(scriptElement); // ei toimi, koska solmu ei ole vielä puussa?
		scriptElement.setAttribute("src", ""); // ei toimi
	}		
	clearInterval(intervalID); // remove the timer
}
*/

	//for (i in scripts) {
	for (var i=0; i < scripts.length; i++) {
		var script = scripts[i];
		var scriptElement = document.createElement("script");
		scriptElement.setAttribute("src", script);
		scriptElement.setAttribute("type", "text/Javascript");
		scriptElement.setAttribute("charset", "UTF-8");
		
		headTag.insertBefore(scriptElement, headTag.firstChild);
	}
}

function addOnload(myfunc) {
	if (window.addEventListener)
		window.addEventListener("load", myfunc, false);
	else if (window.attachEvent)
		window.attachEvent("onload", myfunc);
}

var scripts = 0;

function addScriptLoaded() {
	scripts++;

	// if all the scripts are loaded, create the ONKI instances and generate UI components
	if (scripts == 6) {

		var scriptElement = document.createElement("script");
		var lang = "";
		if (UILang != undefined)
			lang = "&l="+UILang;
		scriptElement.setAttribute("src", "http://www.yso.fi/onki2/get?m=ontologies&format=json-onkiselector&callback=createOnkis"+lang);
		scriptElement.setAttribute("type", "text/Javascript");
		scriptElement.setAttribute("charset", "UTF-8");
		
		var headTag = document.getElementsByTagName("head")[0];
		headTag.insertBefore(scriptElement, headTag.firstChild);
		
		/*
		createOnki("koko", ysourl+"/onki/koko/", "KOKO Ontology", true, true);
		createOnki("sapo", ysourl+"/onki/sapo/", "The Finnish Time-Location Ontology", true, true);
		createOnki("yso", ysourl+"/onki/yso/", "General Upper Finnish Ontology", true, true);
		createOnki("suo", "http://demo.seco.tkk.fi/onkipaikka/", "Geographical Data Search", false, true);
		createOnki("toimo", ysourl+"/onki/toimo/", "The Actor Ontology", false, false);
		//createOnki("toimo", "http://wrk-4.seco.hut.fi:8080/onkitoimija/", "The Actor Ontology", false, true);
		createOnki("mao", ysourl+"/onki/mao/", "Museoalan ontologia", false, true);
		createOnki("ic", ysourl+"/onki/ic/", "Iconclass", false, true);
		createOnki("hpmulti", ysourl+"/onki/hpmulti/", "HPMULTI", true, true);
		createOnki("mesh", ysourl+"/onki/mesh/", "MeSH", true, true);
		createOnki("tao", ysourl+"/onki/tao/", "Taideteollisuusalan ontologia", true, true);
		createOnki("valo", ysourl+"/onki/valo/", "The Finnish Photography Ontology", true, true);
		createOnki("afo", ysourl+"/onki/afo/", "Viikin tiedekirjaston ontologia", true, true);
		createOnki("ysa", ysourl+"/onki/ysa/", "General Finnish Thesaurus", true, true);
		createOnki("musa", ysourl+"/onki/musa/", "Music Thesaurus", true, true);
		createOnki("kauno", ysourl+"/onki/kaunokki/", "The Kaunokki Ontology", false, true);
		createOnki("tervesuomi-genre", ysourl+"/onki/tervesuomi-genre/", "Tervesuomi-genre", true, true);
		createOnki("medium", ysourl+"/onki/medium/", "Tervesuomi-medium", true, true);
		createOnki("medieqmesh", ysourl+"/onki/medieqmesh/", "MeSH", false, true);
		createOnki("koordinaatit", "http://demo.seco.tkk.fi/onkigeo/", "Coordinate fetching", true, true);
		createOnki("smartmuseum-agegroup", ysourl+"/onki/smartmuseum-agegroup/", "Smartmuseum - Age group", false, false);
		createOnki("smartmuseum-language", ysourl+"/onki/smartmuseum-language/", "Smartmuseum - Language", false, false);
		createOnki("lusto-time", ysourl+"/onki/lusto-time/", "Lusto: Aikaontologia", false, false);
		createOnki("suo-classes", ysourl+"/onki/suo-classes/", "The Finnish Geo-ontology Classes", false, true);
		createOnki("avio", ysourl+"/onki/avio/", "Ontology of the Birds of the World", true, true);
		createOnki("mamo", ysourl+"/onki/mamo/", "Ontology of the Mammals of the World", true, true);
		createOnki("unspsc", ysourl+"/onki/unspsc/", "The United Nations Standard Products and Services Code", true, true);
		createOnki("muso", ysourl+"/onki/muso/", "Ontology for Music", true, true);
		createOnki("vnas", ysourl+"/onki/vnas/", "Valtioneuvoston asiasanasto", true, true);
		createOnki("tero", ysourl+"/onki/tero/", "Ontology on Health Promotion", true, true);
		createOnki("ipsv", ysourl+"/onki/ipsv/", "Integrated Public Sector Vocabulary", false, true);
		createOnki("kauno", ysourl+"/onki/kauno/", "Kaunokki Ontology", false, true);
		createOnki("kaunokki", ysourl+"/onki/kaunokki/", "Kaunokki Thesaurus", false, true);
		createOnki("mesa", ysourl+"/onki/mesa/", "Merenkulkualan asiasanasto", true, true);
		createOnki("stameta", ysourl+"/onki/stameta/", "Stakesin asiasanasto STAMETA", true, true);
		createOnki("tervesuomi-section", ysourl+"/onki/tervesuomi-section/", "TerveSuomi-portaalin osioluokitus", true, true);
		createOnki("lcsh", ysourl+"/onki/lcsh/", "Library of Congress Subject Headings", false, false);
		createOnki("aat", ysourl+"/onki/aat/", "Art and Architecture Thesaurus", false, false);
		
		createOnki(null, null, null, null, true);
		
		//Check whether onki.js is loaded from public onki (www.yso.fi) or not
		if (publicOnki == false)
			createOnki("local", host.substring(0, host.indexOf("app/")), "Local ontology", false, true);

		initOnki();
		*/
	}
}

function sortOntologies(a, b) { 
	return a['http://www.yso.fi/onki-ns/onki/abbreviation'] > b['http://www.yso.fi/onki-ns/onki/abbreviation'];
}

function createOnkis(data) {
	
	data.sort(sortOntologies);
	
	//for (i in data) {
	for (var i=0; i < data.length; i++) {
		
		var abbr = data[i]['http://www.yso.fi/onki-ns/onki/abbreviation'];
				
		var url;
		if (data[i]['http://www.yso.fi/onki-ns/onki/backendUrl']) {
			if (data[i]['http://www.yso.fi/onki-ns/onki/backendUrl'].indexOf("http://www.yso.fi/onki") == 0)
				url = ysourl + "/onki/" + data[i]['http://www.yso.fi/onki-ns/onki/abbreviation'] + "/";
			else
				url = data[i]['http://www.yso.fi/onki-ns/onki/backendUrl'];
		}
		else if (data[i]['http://www.yso.fi/onki-ns/onki/customBrowser'])
			url = data[i]['http://www.yso.fi/onki-ns/onki/customBrowser'];

		var label = data[i]['http://www.w3.org/2000\/01/rdf-schema#label'];
		
		var uriIsUrl = false;
		if (data[i]['http://www.yso.fi/onki-ns/onki/uriIsUrl'] && data[i]['http://www.yso.fi/onki-ns/onki/uriIsUrl'].indexOf("true") != -1)
			uriIsUrl = true;

		var browser = false;
		if (data[i]['http://www.yso.fi/onki-ns/onki/browser'] && data[i]['http://www.yso.fi/onki-ns/onki/browser'].indexOf("true") != -1)
			browser = true;

		createOnki(abbr, url, label, uriIsUrl, browser);
	}
	
	createOnki(null, null, null, null, true);

	//Check whether onki.js is loaded from public onki (www.yso.fi) or not
	if (publicOnki == false)
		createOnki("local", host.substring(0, host.indexOf("app/")), "Local ontology", false, true);

	initOnki();
}

// add onkiLoadScripts as window's onload event listener
addOnload(loadOnkiScripts);