dojo.provide("semweb.graph.Graph");
dojo.require("semweb.graph.Node");

semweb.graph.Graph = Class.create();
semweb.graph.Graph.prototype = {
  initialize: function() {
    this.nodeHash = $H({});
    this.nodeList = [];
    this.dirty = false;
  },
  
  addNode: function(id,value) {
    if (value == undefined) value=id;
    var node = this.nodeHash[id];
    if (node == undefined) {
      node = new semweb.graph.Node(this,id,value);
      this.nodeHash[id] = node;
      this.dirty = true;
    } else {
      node.value = value;
    }
    return node;
  },
  
  getNode: function(id) {
    return this.nodeHash[id];
  },
  
  removeNode: function(node) {
    node.remove();
  },
  
  nodes: function() {
    this.cache();
    return this.nodeList;
  },
  
  cache: function() {
    if (this.dirty) { 
      this.nodeList = this.nodeHash.values();
      this.dirty = false;
    }
  }
  
};

