package fi.seco.semweb.infrastructure;

import java.util.ArrayList;
import java.util.Collection;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.FileSystemXmlApplicationContext;

public class SecoRegistry {

	private static ApplicationContext context;

	private static String path = "context";

	public SecoRegistry() { }

	public static class SecoRegistryConfigurator {
		public Collection<String> getContextLocations() {
			ArrayList<String> tmp = new ArrayList<String>();
			tmp.add(path+"/WEB-INF/classes/applicationContext.xml");
			return tmp;
		}

		public ApplicationContext getContext() {
			return new FileSystemXmlApplicationContext(getContextLocations().toArray(new String[0]));
		}
	}

	private static SecoRegistryConfigurator configurator = new SecoRegistryConfigurator();

	public static void setConfigurator(SecoRegistryConfigurator configurator) {
		SecoRegistry.configurator=configurator;
	}

	public static ApplicationContext getContext() {
		if (context==null) setContext(configurator.getContext());
		return context;
	}

	public static void setContext(ApplicationContext context) {
		SecoRegistry.context=context;
	}

	public static Object getService(String beanName) {
		return getContext().getBean(beanName);
	}

	public static <T> T getService(Class <T> clazz) {
		return getService(clazz.getName(),clazz);
	}

	@SuppressWarnings("unchecked")
	public static <T> T getService(String beanName, Class<T> clazz) {
		return (T) getContext().getBean(beanName,clazz);
	}

}
