package fi.seco.semweb.infrastructure.jena;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;

import javax.sql.DataSource;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import fi.seco.semweb.util.sql.KeepAliveConnection;

public class JenaDBModelSource extends JenaModelSource {

	private static Log log = LogFactory.getLog(JenaDBModelSource.class);
	private DataSource ds;
	private String model;
	private Connection conn;
	private String type;

	public JenaDBModelSource() { }

	public JenaDBModelSource(DataSource ds, String key, String type, String model) {
		super(key);
		this.ds=ds;
		this.type=type;
		this.model=model;
	}

	public String getModel() {
		return model;
	}
	public void setModel(String model) {
		this.model = model;
	}

	public void setDataSource(DataSource ds) {
		this.ds=ds;
	}

	public DataSource getDataSource() {
		return ds;
	}

	public String getType() {
		return type;
	}

	@Override
	public String toString() {
		return "key: "+getKey()+", model: "+getModel()+", type: "+type+", connection: "+ds.toString();
	}

	public void setType(String type) {
		this.type = type;
	}
	
	public long getLastModified() {
		Connection sqconn = getConnection();
		try {
			ResultSet rs = sqconn.createStatement().executeQuery("select LastModified from jena_graph where Name='"+getModel()+"'");
			if (!rs.next()) {
				log.error("SQL error getting last modification date, not set in database");
				return -1;
			}
			Timestamp ret = rs.getTimestamp(1);
			if (ret==null) {
				log.error("SQL error getting last modification date, not set in database");
				return -1;
			}
			return ret.getTime();
		} catch (SQLException e) {
			log.error("SQL error getting last modification date",e);
			return -1;
		}

/*		try {
			Connection sqconn = getConnection();
			ResultSet rs = sqconn.createStatement().executeQuery("select LastModified from jena_graph where Name='"+getModel()+"'");
			rs.next();
			return rs.getTimestamp(1).getTime();
		} catch (SQLException e) {
			log.error("Couldn't get last modified timestamp from SQL",e);
		}*/
	}
	
	public Connection getConnection() {
		try {
			if (conn==null) conn = new KeepAliveConnection(getDataSource().getConnection());
		} catch (SQLException e) {
			log.error("",e);
		}
		return conn;
	}

	
}
