package fi.seco.semweb.model;

import java.io.ObjectStreamException;
import java.io.StringReader;
import java.io.StringWriter;

import org.apache.commons.lang.ObjectUtils;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.Resource;
import fi.seco.semweb.util.JenaHelper;

public class ModelHoldingObject extends BaseObject implements IModelHoldingObject {
	/**
	 *
	 */
	private static final long serialVersionUID = 1L;
	protected transient Model model;

	public ModelHoldingObject() {

	}

	public ModelHoldingObject(Model model) {
		this.model=model;
	}

	public Resource r(String uri) {
		return JenaHelper.r(model,uri);
	}

	public Resource r() {
		return model.createResource();
	}

	public Resource i(String classUri) {
		return JenaHelper.i(model,classUri);
	}

	public Resource i(Resource classResource) {
		return JenaHelper.i(model,classResource);
	}

	public Resource i(String uri, String classUri) {
		return JenaHelper.i(model,uri,classUri);
	}

	public Property p(String uri) {
		return JenaHelper.p(model,uri);
	}

	public Model getModel() {
		return model;
	}

	public void setModel(Model model) {
		this.model = model;
	}

	@Override
	public String toString() {
		return ObjectUtils.identityToString(this);
	}

	private String serializedForm;

	protected Object writeReplace() throws ObjectStreamException {
		StringWriter t = new StringWriter();
		model.write(t,"RDF/XML-ABBREV");
		serializedForm=t.toString();
		return this;
	}

	protected Object readResolve() throws ObjectStreamException {
		model = ModelFactory.createDefaultModel();
		model.read(new StringReader(serializedForm),null);
		return this;
	}

}
