package fi.seco.semweb.model;

import com.hp.hpl.jena.datatypes.RDFDatatype;
import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.rdf.model.AnonId;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.RDFVisitor;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.Statement;

public class ResourceObject extends ResourceHoldingObject implements IResourceObject {

	private static final long serialVersionUID = 1L;

	public ResourceObject(Resource resource) {
		super(resource);
	}

	public AnonId getId() {
		return resource.getId();
	}

	@Deprecated
	public Node getNode() {
		return resource.getNode();
	}

	public boolean hasURI(String arg0) {
		return resource.hasURI(arg0);
	}

	public String getURI() {
		return resource.getURI();
	}

	public String getNameSpace() {
		return resource.getNameSpace();
	}

	public String getLocalName() {
		return resource.getLocalName();
	}

	public Statement getRequiredProperty(Property arg0) {
		return resource.getRequiredProperty(arg0);
	}

	public Statement getProperty(Property arg0) {
		return resource.getProperty(arg0);
	}

	@Deprecated
	public Resource addProperty(Property arg0, boolean arg1) {
		return resource.addProperty(arg0,arg1);
	}

	@Deprecated
	public Resource addProperty(Property arg0, long arg1) {
		return resource.addProperty(arg0,arg1);
	}

	@Deprecated
	public Resource addProperty(Property arg0, char arg1) {
		return resource.addProperty(arg0,arg1);
	}

	@Deprecated
	public Resource addProperty(Property arg0, float arg1) {
		return resource.addProperty(arg0,arg1);
	}

	@Deprecated
	public Resource addProperty(Property arg0, double arg1) {
		return resource.addProperty(arg0,arg1);
	}

	public Resource addProperty(Property arg0, String arg1) {
		return resource.addProperty(arg0,arg1);
	}

	public Resource addProperty(Property arg0, String arg1, String arg2) {
		return resource.addProperty(arg0,arg1,arg2);
	}

	@Deprecated
	public Resource addProperty(Property arg0, Object arg1) {
		return resource.addProperty(arg0,arg1);
	}

	public Resource addProperty(Property arg0, RDFNode arg1) {
		return resource.addProperty(arg0,arg1);
	}

	public boolean hasProperty(Property arg0) {
		return resource.hasProperty(arg0);
	}

	@Deprecated
	public boolean hasProperty(Property arg0, boolean arg1) {
		return resource.hasProperty(arg0,arg1);
	}

	@Deprecated
	public boolean hasProperty(Property arg0, long arg1) {
		return resource.hasProperty(arg0,arg1);
	}

	@Deprecated
	public boolean hasProperty(Property arg0, char arg1) {
		return resource.hasProperty(arg0,arg1);
	}

	@Deprecated
	public boolean hasProperty(Property arg0, float arg1) {
		return resource.hasProperty(arg0,arg1);
	}

	@Deprecated
	public boolean hasProperty(Property arg0, double arg1) {
		return resource.hasProperty(arg0,arg1);
	}

	public boolean hasProperty(Property arg0, String arg1) {
		return resource.hasProperty(arg0,arg1);
	}

	public boolean hasProperty(Property arg0, String arg1, String arg2) {
		return resource.hasProperty(arg0,arg1,arg2);
	}

	@Deprecated
	public boolean hasProperty(Property arg0, Object arg1) {
		return resource.hasProperty(arg0,arg1);
	}

	public boolean hasProperty(Property arg0, RDFNode arg1) {
		return resource.hasProperty(arg0,arg1);
	}

	public Resource removeProperties() {
		return resource.removeProperties();
	}

	public Resource removeAll(Property arg0) {
		return resource.removeAll(arg0);
	}

	public Resource begin() {
		return resource.begin();
	}

	public Resource abort() {
		return resource.abort();
	}

	public Resource commit() {
		return resource.commit();
	}

	@Override
	public Model getModel() {
		return resource.getModel();
	}

	public boolean isAnon() {
		return resource.isAnon();
	}

	public boolean isLiteral() {
		return resource.isLiteral();
	}

	public boolean isURIResource() {
		return resource.isURIResource();
	}

	public boolean isResource() {
		return resource.isResource();
	}

	@SuppressWarnings("unchecked")
	public RDFNode as(Class arg0) {
		return resource.as(arg0);
	}

	@SuppressWarnings("unchecked")
	public boolean canAs(Class arg0) {
		return resource.canAs(arg0);
	}

	public RDFNode inModel(Model arg0) {
		return resource.inModel(arg0);
	}

	public Object visitWith(RDFVisitor arg0) {
		return resource.visitWith(arg0);
	}

	public Node asNode() {
		return resource.asNode();
	}

	@Override public int hashCode() {
		return resource.hashCode();
	}

	@Override public boolean equals(Object o) {
		return resource.equals(o);
	}

	public Resource addProperty(Property arg0, String arg1, RDFDatatype arg2) {
		return resource.addProperty(arg0, arg1,arg2);
	}

}