package fi.seco.semweb.service.indexing.tree.model;

import java.util.Collections;

import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;

import fi.seco.semweb.util.JenaHelper;
import fi.seco.semweb.util.LString;
import fi.seco.semweb.util.iterator.AMappingIterator;

public class OntodellaCategory extends AOntodellaCategory implements IInputNode<LString> {

	public OntodellaCategory(Resource r) {
		super(r);
	}

	public LString getInfo() {
		return new LString(resource);
	}

	public Iterable<? extends IInputNode<LString>> getSubNodes() {
		if (!resource.hasProperty(subCategories)) return Collections.emptyList();
		return new AMappingIterator<RDFNode, IInputNode<LString>>(JenaHelper.getListItems(resource, subCategories)) {

			@Override
			public IInputNode<LString> map(RDFNode src) {
				return new OntodellaCategory((Resource)src);
			}

		};
	}

}
