package fi.seco.semweb.service.lucenegator;

import org.apache.lucene.search.HitCollector;

/**
 * A very simple HitCollector that only keeps track of the number of hits.
 * Used for queries where the only result of interest is the amount of hits.
 * @author oisuomin
 *
 */

public class CountingHitCollector extends HitCollector {
	
	int count = 0;
	
	@Override
	public void collect(int doc, float score) {
		++count;
	}
	
	/**
	 * get the number of hits
	 * @return number of hits
	 */
	public int getCount() {
		return count;
	}

}
