package fi.seco.semweb.service.poka.frame;

import java.util.HashSet;

/**
 * Entinen Sentencen sisluokka. Sislt yksittisen 
 * tokenin tiedot helposti kyseltvn, ei tarvi ronkkia xml:
 * (kyllkin aiheuttaa typer tehottomuutta ja toisteisuutta?)
 * 
 * --> TODO: voisi olla jrkev luoda jo dokumentin parsimisvaiheen yhteydess
 *     PokaDoctorissa
 * 
 * @author alm
 *
 */
	
	public class Token {
		
		private int dHead;
		private String depend; //TODO: numero vai alkup. String?		
		private String morpho;
		private String syntax;
		private String nodetype;
		private String text;
		private String lemma;
		private String desc;
		
		private int tokenID;
				
		private boolean dependSet;
		//vai riittk solmun tyyppi? kanta / verbi / pronomini jne?
		private boolean morphoSet;
		
		public Token() {
			
			this.dHead = -2;
//			this.text = ""; //laiskan miehen st 
			this.text = null;
			this.lemma = null;
			this.dependSet = false;
			this.depend = null;
			this.morpho = null;
			this.syntax = null;
			
			this.desc = "";
			this.morphoSet = false;
		}
		
		public void setID(int id) {
			this.tokenID = id;
		}

		/**
		 * 
		 * @param position monesko token lauseessa
		 */
	
		public void setHead(int head) {
			this.dHead = head;
		}
		
		public void setDepend(String depend) {
			this.depend = depend;
			this.dependSet = true;
		}
		
		public void setMorpho(String morpho) {
			this.morphoSet = true;
			this.morpho = morpho;
		}
		
		public void setSyntax(String syntax) {
			this.syntax = syntax;
		}
		
		public  void setNodetype(String nodetype) {
			this.nodetype = nodetype;
		}
		public String getNodeType() {
			return this.nodetype;
		}
		
		public void setText(String text) {
			this.text = text;
		}
		public void setLemma(String lemma) {
			this.lemma = lemma;
		}
				
		public void setDesc(String desc) {
			this.desc = desc;
		}
		public String getDesc() {
			return this.desc;
		}
		
		public String getText() {
			return this.text;
		}
		public String getLemma() {
			return this.lemma;
		}
		
		public String getMorpho() {
			if(this.morpho == null) {
				return null;
			}
			return this.morpho;
		}
		public String getSyntax() {
			if(this.syntax == null) {
				return null;
			}
			return this.syntax;
		}
		
		public boolean morphoSet() {
			return this.morphoSet;
		}
		
		public int getDHead() {
			return this.dHead;
		}
		
		public String getDType() {
			return this.depend;
		}
		
		public int getID() {
			return this.tokenID;
		}
		
				
/*		
TODO 	private void setID(String nameid / #ksite / jne) 
*/		
		public String toString() {

			String headTemp;
			if(dependSet) {
				headTemp = String.valueOf(this.dHead);
			} else {
				headTemp = "";
			}
						
			return "type: " +this.nodetype+"\n"+
				   "text: " +this.text+"\n"+
				   "mrph: " +this.morpho+"\n"+
				   "sntx: " +this.syntax+"\n"+
				   "dpnd: " +this.depend+" "+headTemp+"\n";
		}		
		
	}
