/**
 * Konfiguroidaan nimi / ei-nimi -luettelot
 *  (NameExtractorissa name.list, notAName.list)
 */

package fi.seco.semweb.service.poka.name;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.BufferedReader;
import java.io.File;

import java.util.HashSet;
import java.util.Iterator;

import fi.seco.semweb.service.poka.Configuration;

public class NameConfig {

	private final String NOTANAMEID = "not a name:";
	private final String NAMEID = "name:";

	private String name;
	private String notAName;

	private File config,
                 nFile,
                 nAnFile;

	private HashSet<String> names;
	private HashSet<String> noNames;

	public NameConfig() throws FileNotFoundException {

		BufferedReader in;
		String temp;

		config = new File(Configuration.NAMECONFIGFILE);
		if(!config.exists()) {
			System.out.println("NameConfig.java / error: Config file "+Configuration.NAMECONFIGFILE+" does not exist!");
			throw new FileNotFoundException();
			//System.exit(0);
		} else {
			try {
				in = new BufferedReader(
						new InputStreamReader(
					  		new FileInputStream(config)));
			
				while((temp = in.readLine()) != null) {
					if(temp.startsWith(NOTANAMEID)) {
						notAName = temp.substring(NOTANAMEID.length()+1);
					} else if(temp.startsWith(NAMEID)) {
						name = temp.substring(NAMEID.length()+1);
					}
				}
			} catch(Exception e) {
				System.out.println("Error reading conf: " + e);
				System.exit(0);
			}
			if(name == null || notAName == null) {
				System.out.println("Error in conf file: files are not defined!");
				System.exit(0);
			}

			nFile = new File(name);
			names = new HashSet <String>();
			if(nFile.exists()) {
				try {
				in = new BufferedReader(
						new InputStreamReader(
					  		new FileInputStream(nFile)));
	
					while((temp = in.readLine()) != null) {
						names.add(temp);
					}
				}  catch(Exception e) {
					System.out.println("Error reading name file: " + e);
					System.exit(0);
				}
			} else {
				System.out.println("Name file '"+name+"' does not exist!"); 	
			}


			nAnFile = new File(notAName);
			noNames = new HashSet <String>();
			if(nAnFile.exists()) {
				try {
				in = new BufferedReader(
						new InputStreamReader(
					  		new FileInputStream(nAnFile)));
	
					while((temp = in.readLine()) != null) {
						noNames.add(temp);
					}
				}  catch(Exception e) {
					System.out.println("Error reading name file: " + e);
					System.exit(0);
				}
			} else {
				System.out.println("Not a name file '"+notAName+"' does not exist!"); 	
			}

		}
	}

	public HashSet<String> getNamelist() {
		return names;
	}
	
	public boolean setNamelist(HashSet <String> neuNames) {
		try {
			PrintWriter nameSetWriter = new PrintWriter(nFile);
			
			Iterator <String> i = neuNames.iterator();
			while(i.hasNext()) {
				nameSetWriter.println(i.next());
			}
			nameSetWriter.close();
			return true;
		}catch(IOException e) {
			System.err.println("Error writing nameList: "+e);
			//System.exit(0);
		}
		return false;
	}
	
	
	public HashSet<String> getNoNamelist() {
		return noNames;
	}


	public boolean setNoNamelist(HashSet <String> neuNoNames) {
		try {
			PrintWriter nameSetWriter = new PrintWriter(nAnFile);
			
			Iterator <String> i = neuNoNames.iterator();
			while(i.hasNext()) {
				nameSetWriter.println(i.next());
			}
			nameSetWriter.close();
			return true;
		}catch(IOException e) {
			System.err.println("Error writing nameList: "+e);
			//System.exit(0);
		}
		return false;
	}
	
	
	public static void main(String [] args) throws FileNotFoundException {
		NameConfig my = new NameConfig();
	}
}
