package fi.seco.semweb.service.poka.tokenIndexer;

/**
 * Qizx-Xquery-implementaatiota. Xquery-kyselyiden kohdistus
 * XML (inputSource) -objekteihin.
 */

import java.io.InputStreamReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.BufferedReader;

import java.net.*;

import java.util.StringTokenizer;

import net.axyana.qizxopen.xquery.*;
import net.axyana.qizxopen.dm.*;

import org.xml.sax.InputSource;

public class QizxImpl {

  private String filename = null;
  //private InputSource in;
  private Socket fdgSocket;

  private PrintWriter out;
  
  private String xmlOutput;


  private BufferedReader bf;

  private XQueryDataSource ds;
  private XQueryBasicEngine be;
  private XQueryConnection connection;


/**
 * Port for Connexor's FDG-parser
 */
  private final int FDGPORT = 10102;

	public QizxImpl(InputSource is) {

		try {
			be = new XQueryBasicEngine();
			be.startup();
			ds = be.getDataSource("");
			connection = ds.getConnection();
			this.setInput(is);
		} catch(Exception e) {
			System.err.println("konstrukori: " +e);
			System.exit(0);
		}

	}


	private void setInput(InputSource is) {
		try {

			connection.setInputDocument(is);
				
		} catch( IndexOutOfBoundsException e ) {
			System.err.println("Args missing: " + e);
		} catch( XQueryException e ) {
			System.err.println("Query compile error: " + e);
		} catch ( Exception e) {
			System.err.println("SetInput / Something happened: ");
			e.printStackTrace();
		} 
	}

	public XQResultSequence sequenceQuery(String query) { 
		try {

			XQueryExpression q = connection.createExpression();
			XQResultSequence value = q.executeQuery( query );
			return value;
		} catch(XQueryException e) {
			e.printStackTrace();
			System.exit(0); 			
		}
		return null;
	}
	
	
	

	public String query(String query) {
		
		StringWriter sw = new StringWriter();
		//System.out.print("Suoritetaan kyselyä...");
			 

		XQueryExpression q;
		XMLSerialOptions ops = new XMLSerialOptions();
		ops.setOption("omit-xml-declaration", "yes");
		ops.setOption("indent", "yes");
		String result = null;

		try {
			q = connection.createExpression();
			result = q.executeQuery( query, ops );
		} catch( IndexOutOfBoundsException e ) {
			System.err.println("Args missing: " + e);
		} catch (XQEvalException ee) {
    		System.err.println("XQEval: " + ee);
		} catch( XQueryException e ) {
			System.err.println("Query compile error: " + e);
		} catch ( Exception e) {
			System.err.println("Something happened: " + e);
		} 
		//System.out.println("...valmis!");
		return result;
	}



  /** Main method to run from the command line.    */
  public static void main (String[] args) 
							throws Exception {
	
    
  }	
  
}

