/**
 * Palautti lemmat termossa, nyt ei käytössä.
 */

package fi.seco.semweb.service.poka.util;

import java.io.IOException;

import org.xml.sax.helpers.*;
import org.xml.sax.*;

public class LemmaParser extends DefaultHandler {

	private StringBuffer result;
	private XMLReader xr;
	private boolean lemmaStart;
	public LemmaParser() {
		super();
		try {
			xr = XMLReaderFactory.createXMLReader();
			xr.setContentHandler(this);
			xr.setErrorHandler(this);
		} catch(SAXException e) {
			System.err.println("LemmaParser / SAXEXP: "+e);
			//System.exit(0);
		}
	}
	
	public void parse(InputSource input) {
		this.result = new StringBuffer();
		this.lemmaStart = false;
		
		try {
//			System.out.print("parsitaan...");
			xr.parse(input);
//			System.out.println("...ok!");
		} catch(SAXParseException e) {
			System.err.println("LemmaParser / SAXPARSE: "+e);
			//System.exit(0);
		} catch(SAXException e) {
			System.err.println("LemmaParser / SAXEXP: "+e);
			//System.exit(0);
		} catch(IOException e) {
			System.err.println("LemmaParser / IOEXP: "+ e);
			//System.exit(0);
		} 
	}
	
	public String getResult() {
		return this.result.toString().trim();
	}
	
	 public void startElement (String uri, String name,
		      String qName, Attributes atts) {
		 if(qName.equals("lemma")) {
			 this.lemmaStart = true;
		 }
	 }
	 
	 public void endElement (String uri, String name, String qName) {
		 if(qName.equals("lemma")) {
			 this.lemmaStart = false;		 
		 }
	 }
	 
	 public void characters (char ch[], int start, int length) {
		 if(lemmaStart) {
			 for (int i = start; i < start + length; i++) {

	    			switch (ch[i]) {
	    			
	    			case '&':
	    				result.append("&amp;");
	    				break;
	    			case '>':
	    				result.append("&gt;");
	    				break;
	    			case '<':
	    				result.append("&lt;");
	    				break;
	    			case '\'':
	    				result.append("'"); 
	    				break;
	    			case '\\':	
	    				result.append("\\\\");
	 				break;
	    			case '"':
	    				result.append("\"");
			        break;    
	    			case '\n':
	    				result.append("\\n");
	    				break;
	    				
	    			case '\r':
	    				result.append("\\r");
	    				break;

	    			case '\t':
	    				result.append("\\t");
	    				break;

	    			default:
	    				result.append(ch[i]);
	    				break;
	    			}
	    		}
			
			result.append(" ");
			 
		 } else {
			 return;
		 }
	
	 }
	 
	   /** This method is called when warnings occur */
	    public void warning(SAXParseException exception) {
	        System.err.println("WARNING: line " + exception.getLineNumber() + ": "+
	                           exception.getMessage());
	    }

	    /** This method is called when errors occur */
	    public void error(SAXParseException exception) {
	        System.err.println("ERROR: line " + exception.getLineNumber() + ": " +
	                           exception.getMessage());
	    }

	    /** This method is called when non-recoverable errors occur. */
	    public void fatalError(SAXParseException exception) throws SAXException {
	        System.err.println("FATAL: line " + exception.getLineNumber() + ": " +
	                           exception.getMessage());
	        throw(exception);
	    }
	 
}
