package fi.seco.semweb.service.poka.util;

/**
 * Instanssiontologialle tarkoitettu trie-toteutus. 
 * Keskeisenä erona indeksoitavan käsitteen tyypin
 * lisäys indeksiin.
 */

import java.util.Iterator;

import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.Resource;

import fi.seco.semweb.service.poka.Configuration;

public class TrieInstanceIndex extends TrieIndex {

	private Property termType;
	
	public TrieInstanceIndex(String termFile, 
							 String encoding,
							 String termNameSpace) {

		super(termFile, encoding, termNameSpace);
		
		this.termType = terms.getProperty(termNameSpace, "type");
		
	}
	//TODO: vastaava poistometodi!
	public boolean createTerm(String uri, String name, String type) {
		String lemma = this.lemmatizer.lemma(name);
				
		Resource r = terms.createResource(uri);
		r.addProperty(termlabel, lemma);
		r.addProperty(termType, type);
		this.put(lemma, uri);
		return true;		
	}
	
	public String getType(String uri) {
		Resource r = terms.getResource(uri);
		if(r == null) {
			return null;
		} else {
			return r.getProperty(termType).getLiteral().getString();
		}
	}
	
	/**
	 * Palauttaa instanssien tyyppejä vastaavat URIt Stringinä ilman
	 * nimiavaruutta
	 * 
	 */
	public String getConceptString(String term) {
		Iterator it = this.getUris(term).iterator();
		String result = "";
		String temp;
		while(it.hasNext()) {
			temp = this.getType((String)it.next());
			result += temp.substring(temp.indexOf('#')+1)+" ";
		}
		return result.trim();
	}
		
	public static void main(String [] args) {
		
		//testiä: näyttää toimivan
		TrieInstanceIndex neu = new TrieInstanceIndex("/home/alm/termo/OpasTerms.rdf",
										"ISO-8859-1", Configuration.DEFAULTFRAMENAMESPACE);
		System.out.println(neu.matchByPrefix("gar"));
		java.util.HashSet <String> a = neu.getUris("garfield");

		neu.createTerm("http://yso.fi/opas#jnafiqn", "garfield","http://yso.fi/YSO#koira");
		System.out.println("garfield täsmää ureihin:");
		for(String s: a) {
			System.out.println("uri: "+s+", tyyppi: "+neu.getType(s));
		}
		
		System.out.println(neu.getConceptString("garfield"));

		
		
	}
	
}
