package fi.seco.semweb.service.search.query;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class IntersectionQuery implements IQueryPart {

	private static final Log log = LogFactory.getLog(IntersectionQuery.class);

	private Collection<IQueryPart> parts;

	public IntersectionQuery() {
		this.parts = new ArrayList<IQueryPart>();
	}

	public IntersectionQuery(Collection<IQueryPart> parts) {
		this.parts=parts;
	}

	public Collection<IQueryPart> getParts() {
		return parts;
	}

	public IntersectionQuery addToIntersection(IQueryPart part) {
		if (part instanceof IntersectionQuery) for (IQueryPart o : ((IntersectionQuery)part).getParts()) parts.add(o);
			else parts.add(part);
		return this;
	}

	public Object getCacheKey() {
		Set<Object> ret = new HashSet<Object>();
		for (IQueryPart part : parts)
			if (part.getCacheKey()==null) return null;
			else if (!ret.add(part.getCacheKey())) log.error("Duplicate cache key "+part.getCacheKey().toString()+" in IntersectionQuery "+toString());
		return ret;
	}

}
