package fi.seco.semweb.service.search.query;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class UnionQuery implements IQueryPart {

	private static final Log log = LogFactory.getLog(UnionQuery.class);

	private Collection<IQueryPart> parts = new ArrayList<IQueryPart>();

	public Collection<IQueryPart> getParts() {
		return parts;
	}
	
	public void addToUnion(IQueryPart part) {
		if (part instanceof UnionQuery) for (IQueryPart o : ((UnionQuery)part).getParts()) parts.add(o);
			else parts.add(part);
	}

	public Object getCacheKey() {
		Set<Object> ret = new HashSet<Object>();
		for (IQueryPart part : parts) {
			if (part.getCacheKey()==null) return null;
			else if (!ret.add(part.getCacheKey())) log.error("Duplicate cache key "+part.getCacheKey().toString()+" in UnionQuery "+toString());
		}
		return ret;
	}

}
