package fi.seco.semweb.service.view.categorytree;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.StmtIterator;

import fi.seco.semweb.service.indexing.tree.model.IndexedNode;
import fi.seco.semweb.util.JenaHelper;
import gnu.trove.TIntFloatHashMap;

public class OntodellaItemLinker implements IItemLinker {

	private Log log = LogFactory.getLog(OntodellaItemLinker.class);
	private Model model;

	public OntodellaItemLinker(Model model) {
		this.model=model;
	}

	@SuppressWarnings("unchecked")
	public TIntFloatHashMap getLinkedCategories(CategoryTreeIndexService index, int id, String uri) {
		TIntFloatHashMap ret = new TIntFloatHashMap();
		StmtIterator categories = JenaHelper.listInverseProperties(JenaHelper.p(model,"ogt:topicOf"),JenaHelper.r(model,uri));
		while (categories.hasNext()) {
			Iterable<IndexedNode> cats = index.getNodesByExternalId(categories.nextStatement().getSubject().listProperties(JenaHelper.p(model,"ogt:projectionOf")).nextStatement().getResource().getURI());
			for (IndexedNode<?> c : cats) {
				log.debug("Found category "+c.getNodeId()+"/"+model.shortForm(c.getId())+" for itemURI "+model.shortForm(uri));
				ret.put(c.getNodeId(),1.0f);
			}
		}
		return ret;
	}

}
