package fi.seco.semweb.util.collection.primitive;

import java.util.Collection;

import org.apache.commons.collections.primitives.LongCollection;
import org.apache.commons.collections.primitives.LongIterator;

import fi.seco.semweb.util.iterator.primitive.AObjectToLongMappingIterator;

public abstract class AObjectToLongMappingCollection<O> implements LongCollection {

	Collection<? extends O> col;

	public AObjectToLongMappingCollection(Collection<? extends O> col) {
		this.col=col;
	}
	
	public LongIterator iterator() {
		return new AObjectToLongMappingIterator<O>(col.iterator()) {

			@Override
			public long map(O arg0) {
				return AObjectToLongMappingCollection.this.map(arg0);
			}
			
		};
	}
	
	public abstract long map(O a);

	public boolean add(long arg0) {
		throw new UnsupportedOperationException();
	}

	public boolean addAll(LongCollection arg0) {
		throw new UnsupportedOperationException();
	}

	public void clear() {
		col.clear();
	}

	public boolean contains(long arg0) {
		throw new UnsupportedOperationException();
	}

	public boolean containsAll(LongCollection arg0) {
		throw new UnsupportedOperationException();
	}

	public boolean isEmpty() {
		return col.isEmpty();
	}

	public boolean removeAll(LongCollection arg0) {
		throw new UnsupportedOperationException();
	}

	public boolean removeElement(long arg0) {
		throw new UnsupportedOperationException();
	}

	public boolean retainAll(LongCollection arg0) {
		throw new UnsupportedOperationException();
	}

	public int size() {
		return col.size();
	}

	public long[] toArray() {
		throw new UnsupportedOperationException();
	}

	public long[] toArray(long[] arg0) {
		throw new UnsupportedOperationException();
	}

}
