package fi.seco.semweb.util.dwr;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.directwebremoting.ScriptSession;
import org.directwebremoting.WebContextFactory;

public class JSIHelper {

	@SuppressWarnings("unused")
	private static final Log log = LogFactory.getLog(JSIHelper.class);

	public static HttpSession getSession() {
		return WebContextFactory.get().getSession();
	}

	public static ScriptSession getScriptSession() {
		return WebContextFactory.get().getScriptSession();
	}

	@SuppressWarnings("unchecked")
	public static <T> T getSessionObject(String id) {
		Object widget = getSessionObjectMap().get(id);
		if (widget==null) log.error("getSessionObject for id "+id+" called before the widget was created!");
		return (T) widget;
	}

	@SuppressWarnings("unchecked")
	public static <T> T getSessionObjectThatMayNotExist(String id) {
		Object widget = getSessionObjectMap().get(id);
		return (T) widget;
	}

	@SuppressWarnings("unchecked")
	public static Map<String,Object> getSessionObjectMap() {
		Map<String,Object> cmap = (Map<String, Object>) getScriptSession().getAttribute("widgetRegistry");
		if (cmap==null) {
			cmap = new HashMap<String,Object>();
			getScriptSession().setAttribute("widgetRegistry",cmap);
		}
		return cmap;
	}

	public static void putSessionObject(String id, Object widget) {
		getSessionObjectMap().put(id,widget);
	}
}