package fi.seco.semweb.util.iterator;

import java.util.NoSuchElementException;


public abstract class ALazyGeneratingIterator<E> extends AIterableIterator<E> {

	private E next;

	@Override
	public boolean hasNext() {
		if (next!=null) return true;
		next = generateNext();
		return next!=null;
	}

	protected abstract E generateNext();

	@Override
	public E next() {
		if (hasNext()) {
			E tmp = next;
			next = null;
			return tmp;
		}
		throw new NoSuchElementException();
	}

}
