package fi.seco.semweb.util.iterator;

import java.util.Iterator;

public abstract class ALazyInitializingIterator<E> extends AIterableIterator<E> {

	private Iterator<? extends E> iter;

	@Override
	public boolean hasNext() {
		if (iter==null) iter=initialize();
		return iter.hasNext();
	}

	@Override
	public E next() {
		if (iter==null) iter=initialize();
		return iter.next();
	}
	
	@Override
	public void remove() {
		iter.remove();
	}
	
	protected abstract Iterator<? extends E> initialize(); 

}
