package fi.seco.semweb.util.iterator;

import java.util.Collection;
import java.util.Iterator;

public class BackedIterator<E> extends ALazyInitializingIterator<E> implements IBackedIterator<E> {

	private Collection<E> collection;
	
	public BackedIterator(Collection<E> collection) {
		this.collection=collection;
	}
	
	@Override
	public Iterator<? extends E> initialize() {
		return collection.iterator();
	}
	
	public boolean isCollectionBacked() { return true; }
	
	public Collection<E> getBackingCollection() {
		return collection;
	}

}
