package fi.seco.semweb.util.iterator;

import java.util.NoSuchElementException;

public class EmptyIterator<E> extends AIterableIterator<E> implements ISerializableIterableIterator<E> {

	private static final long serialVersionUID = 1L;
	@SuppressWarnings("unchecked")
	public static final EmptyIterator SHARED_INSTANCE = new EmptyIterator<Object>();

	@Override
	public boolean hasNext() {
		return false;
	}

	@Override
	public E next() {
		throw new NoSuchElementException();
	}

	@Override
	public void remove() {
		throw new UnsupportedOperationException("How can you remove something from an empty iterator?");
	}

	@SuppressWarnings("unchecked")
	public static <T> EmptyIterator<T> getInstance() {
		return SHARED_INSTANCE;
	}

}
