package fi.seco.semweb.util.iterator;

import java.util.Iterator;

import fi.seco.semweb.util.IFilter;

public class FilteringIterator<E> extends ALazyGeneratingIterator<E> {

	IFilter<E> filter;
	Iterator<? extends E> iter;
	
	public FilteringIterator(Iterator<? extends E> iter,IFilter<E> filter) {
		this.iter=iter;
		this.filter=filter;
	}

	public FilteringIterator(Iterable<? extends E> col,IFilter<E> filter) {
		this(col.iterator(),filter);
	}
	
	@Override
	public void remove() {
		iter.remove();
	}

	@Override
	protected E generateNext() {
		while (iter.hasNext()) {
			E tmp = iter.next();
			if (filter.accept(tmp)) {
				return tmp;
			}
		}
		return null;
	}

}
