package fi.seco.semweb.util.iterator;

import java.util.Iterator;
import java.util.LinkedList;

public class IterableExpandingIterator<E> extends ALazyGeneratingIterator<E> {

	Iterator<E> iter;
	LinkedList<Iterator<E>> iterStack = new LinkedList<Iterator<E>>();

	public IterableExpandingIterator(Iterator<E> iter) {
		this.iter=iter;
	}

	public IterableExpandingIterator(Iterable<E> col) {
		this.iter=col.iterator();
	}

	@Override
	public void remove() {
		iter.remove();
	}

	@SuppressWarnings("unchecked")
	@Override
	protected E generateNext() {
		while (iter.hasNext() || !iterStack.isEmpty()) {
			while (!iter.hasNext() && !iterStack.isEmpty()) iter=iterStack.removeFirst();
			if (!iter.hasNext()) return null;
			Object tmp = iter.next();
			if (tmp instanceof Iterable) {
				iterStack.add(iter);
				iter = ((Iterable<E>)tmp).iterator();
			} else if (tmp instanceof Iterator) {
				iterStack.add(iter);
				iter = (Iterator<E>)tmp;
			} else return (E)tmp;
		}
		return null;
	}

}
