package fi.seco.semweb.util.iterator;

import java.util.Iterator;

import fi.seco.semweb.util.IMapper;

public class MappingIterator<O,E> extends AIterableIterator<E> {

	IMapper<O,E> map;
	Iterator<? extends O> iter;

	public MappingIterator(Iterator<? extends O> iter,IMapper<O,E> map) {
		this.iter=iter;
		this.map=map;
	}

	public MappingIterator(Iterable<? extends O> col,IMapper<O,E> map) {
  	  this(col.iterator(),map);
	}

	@Override
	public boolean hasNext() {
		return iter.hasNext();
	}

	@Override
	public E next() {
		return map.map(iter.next());
	}

	@Override
	public void remove() {
		iter.remove();
	}

}
