package fi.seco.semweb.util.iterator.mapiterator;

import org.apache.commons.collections15.MapIterator;

public abstract class ALazyInitializingMapIterator<T1,T2> implements MapIterator<T1,T2> {

	private MapIterator<T1,T2> iter;

	public boolean hasNext() {
		if (iter==null) iter=initialize();
		return iter.hasNext();
	}

	public T1 next() {
		if (iter==null) iter=initialize();
		return iter.next();
	}
	
	protected abstract MapIterator<T1,T2> initialize();

	public T1 getKey() {
		return iter.getKey();
	}

	public T2 getValue() {
		return iter.getValue();
	}

	public void remove() {
		iter.remove();
	}

	public T2 setValue(T2 arg0) {
		return iter.setValue(arg0);
	} 

}
