package fi.seco.semweb.util.lucene;

import java.io.IOException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.lucene.document.Document;
import org.apache.lucene.search.Hit;

public final class NonExceptingHit {
	private Hit hit;
	private static Log log = LogFactory.getLog(NonExceptingHit.class);

	public NonExceptingHit(Hit hit) {
		this.hit=hit;
	}

	@Override
	public final boolean equals(Object o) {
		return hit.equals(o);
	}

	public final String get(String arg0) {
		try {
			return hit.get(arg0);
		} catch (IOException e) {
			log.error("",e);
			return null;
		}
	}

	public final float getBoost() {
		try {
			return hit.getBoost();
		} catch (IOException e) {
			log.error("",e);
			return -1.0f;
		}
	}

	public final Document getDocument() {
		try {
			return hit.getDocument();
		} catch (IOException e) {
			log.error("",e);
			return null;
		}
	}

	public final int getId() {
		try {
			return hit.getId();
		} catch (IOException e) {
			log.error("",e);
			return -1;
		}
	}

	public final float getScore() {
		try {
			return hit.getScore();
		} catch (IOException e) {
			log.error("",e);
			return -1.0f;
		}
	}

	@Override
	public final int hashCode() {
		return hit.hashCode();
	}

	@Override
	public final String toString() {
		return hit.toString();
	}

}
