package fi.seco.semweb.util.map;

import java.util.Collection;
import java.util.Map;
import java.util.Set;

public abstract class AEncapsulatingMap<O,E> implements Map<O,E> {

	protected Map<O,E> map;
	
	AEncapsulatingMap() { }
	
	AEncapsulatingMap(Map<O,E> map) {
		this.map=map;
	}

	public int size() {
		return map.size();
	}

	public boolean isEmpty() {
		return map.isEmpty();
	}

	public boolean containsKey(Object key) {
		return map.containsKey(key);
	}

	public boolean containsValue(Object value) {
		return map.containsValue(value);
	}

	public E get(Object key) {
		return map.get(key);
	}

	public E put(O key, E value) {
		return map.put(key,value);
	}

	public E remove(Object key) {
		return map.remove(key);
	}

	public void putAll(Map<? extends O, ? extends E> t) {
		map.putAll(t);
	}

	public void clear() {
		map.clear();
	}

	public Set<O> keySet() {
		return map.keySet();
	}

	public Collection<E> values() {
		return map.values();
	}

	public Set<Entry<O, E>> entrySet() {
		return map.entrySet();
	}

	@Override
	public String toString() {
		return map.toString();
	}
}
