package fi.seco.semweb.util.map;

import java.util.Collection;
import java.util.Collections;
import java.util.Map;
import java.util.Set;

import org.apache.commons.collections15.IterableMap;
import org.apache.commons.collections15.MapIterator;
import org.apache.commons.collections15.iterators.EmptyMapIterator;

public class EmptyIterableMap<T1,T2> implements IterableMap<T1,T2> {

	@SuppressWarnings("unchecked")
	public static final EmptyIterableMap SHARED_INSTANCE = new EmptyIterableMap<Object, Object>();

	@SuppressWarnings("unchecked")
	public static <T1,T2> EmptyIterableMap<T1,T2> getInstance() {
		return SHARED_INSTANCE;
	}

	@SuppressWarnings("unchecked")
	public MapIterator<T1, T2> mapIterator() {
		return EmptyMapIterator.INSTANCE;
	}

	public void clear() {
	}

	public boolean containsKey(@SuppressWarnings("unused")
	Object arg0) {
		return false;
	}

	public boolean containsValue(@SuppressWarnings("unused")
	Object arg0) {
		return false;
	}

	public Set<Entry<T1, T2>> entrySet() {
		return Collections.emptySet();
	}

	public T2 get(@SuppressWarnings("unused")
	Object arg0) {
		return null;
	}

	public boolean isEmpty() {
		return true;
	}

	public Set<T1> keySet() {
		return Collections.emptySet();
	}

	public T2 put(@SuppressWarnings("unused")
	T1 arg0, @SuppressWarnings("unused")
	T2 arg1) {
		throw new UnsupportedOperationException("Can't put anything to the empty map");
	}

	public void putAll(@SuppressWarnings("unused")
	Map<? extends T1, ? extends T2> arg0) {
		throw new UnsupportedOperationException("Can't put anything to the empty map");
	}

	public T2 remove(@SuppressWarnings("unused")
	Object arg0) {
		return null;
	}

	public int size() {
		return 0;
	}

	public Collection<T2> values() {
		return Collections.emptyList();
	}
}
