package fi.seco.semweb.util.srcgen.templates;

import java.util.*;
import com.ibm.adtech.jastor.*;
import com.ibm.adtech.jastor.jet.*;
import com.ibm.adtech.jastor.inference.*;

/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation 
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.opensource.org/licenses/cpl.php
 * 
 ******************************************************************************/

public class FactoryTemplate implements OntologyTemplate {
  protected static String nl;
  public static synchronized FactoryTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    FactoryTemplate result = new FactoryTemplate();
    nl = null;
    return result;
  }

  protected final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "";
  protected final String TEXT_2 = NL + NL + "package ";
  protected final String TEXT_3 = ";" + NL + "" + NL + "import java.util.Iterator;" + NL + "" + NL + "import com.ibm.adtech.jastor.*;" + NL + "import com.hp.hpl.jena.rdf.model.Resource;" + NL + "import com.hp.hpl.jena.rdf.model.Model;" + NL + "import com.hp.hpl.jena.rdf.model.Statement;" + NL + "import com.hp.hpl.jena.vocabulary.RDF;" + NL + "" + NL + "import fi.seco.semweb.util.JenaHelper;" + NL + "import fi.seco.semweb.util.iterator.ALazyInitializingIterator;" + NL + "import fi.seco.semweb.util.iterator.IIterableIterator;" + NL + "import fi.seco.semweb.util.iterator.AMappingIterator;" + NL + "import fi.seco.semweb.util.iterator.IteratorIterator;" + NL + "import fi.seco.semweb.util.iterator.UniqueFilteringIterator;" + NL + "" + NL + "/**" + NL + " * Factory for instantiating objects for ontology classes in the ";
  protected final String TEXT_4 = " ontology.  The" + NL + " * get methods leave the model unchanged and return a Java view of the object in the model.  The create methods" + NL + " * may add certain baseline properties to the model such as rdf:type and any properties with hasValue restrictions." + NL + " * <p>(URI: ";
  protected final String TEXT_5 = ")</p>" + NL + " * <br>";
  protected final String TEXT_6 = NL + " * RDF Schema Standard Properties <br>";
  protected final String TEXT_7 = NL + " * \t";
  protected final String TEXT_8 = " <br>";
  protected final String TEXT_9 = NL + " * <br>";
  protected final String TEXT_10 = NL + " * Dublin Core Standard Properties <br>";
  protected final String TEXT_11 = NL + " * \t";
  protected final String TEXT_12 = " <br>";
  protected final String TEXT_13 = NL + " * <br>";
  protected final String TEXT_14 = NL + " *\t@version ";
  protected final String TEXT_15 = NL + " */" + NL + "public class ";
  protected final String TEXT_16 = " extends ";
  protected final String TEXT_17 = " { " + NL + "" + NL + "\tprivate static final long serialVersionUID = 1L;" + NL + "" + NL + "\tpublic ";
  protected final String TEXT_18 = "(Model model) {" + NL + "\t\tsuper(model);" + NL + "\t}" + NL;
  protected final String TEXT_19 = NL + NL + "\t/**" + NL + "\t * Create a new instance of ";
  protected final String TEXT_20 = ".  Adds the rdf:type property for the given resource to the model." + NL + "\t * @param resource The resource of the ";
  protected final String TEXT_21 = NL + "\t * @param model the Jena Model." + NL + "\t */" + NL + "\tpublic static ";
  protected final String TEXT_22 = " create";
  protected final String TEXT_23 = "(Resource resource) throws JastorException {" + NL + "\t\treturn ";
  protected final String TEXT_24 = ".create";
  protected final String TEXT_25 = "(resource);" + NL + "\t}" + NL + "\t" + NL + "\t/**" + NL + "\t * Create a new instance of ";
  protected final String TEXT_26 = ".  Adds the rdf:type property for the given resource to the model." + NL + "\t * @param uri The uri of the ";
  protected final String TEXT_27 = NL + "\t * @param model the Jena Model." + NL + "\t */" + NL + "\tpublic static ";
  protected final String TEXT_28 = " create";
  protected final String TEXT_29 = "(String uri, Model model) throws JastorException {" + NL + "\t\t";
  protected final String TEXT_30 = " obj = ";
  protected final String TEXT_31 = ".create";
  protected final String TEXT_32 = "(JenaHelper.r(model,uri));" + NL + "\t\treturn obj;" + NL + "\t}" + NL + "" + NL + "\t/**" + NL + "\t * Create a new instance of ";
  protected final String TEXT_33 = ".  Adds the rdf:type property for the given resource to the model." + NL + "\t * @param uri The uri of the ";
  protected final String TEXT_34 = NL + "\t * @param model the Jena Model." + NL + "\t */" + NL + "\tpublic ";
  protected final String TEXT_35 = " create";
  protected final String TEXT_36 = "(String uri) throws JastorException {" + NL + "\t\treturn create";
  protected final String TEXT_37 = "(r(uri));" + NL + "\t}" + NL + "\t" + NL + "\t/**" + NL + "\t * Create a new instance of ";
  protected final String TEXT_38 = ".  Leaves the model unchanged." + NL + "\t * @param uri The uri of the ";
  protected final String TEXT_39 = NL + "\t * @param model the Jena Model." + NL + "\t */" + NL + "\tpublic static ";
  protected final String TEXT_40 = " get";
  protected final String TEXT_41 = "(String uri, Model model) throws JastorException {" + NL + "\t\treturn get";
  protected final String TEXT_42 = "(JenaHelper.r(model,uri));" + NL + "\t}" + NL + "" + NL + "\t/**" + NL + "\t * Create a new instance of ";
  protected final String TEXT_43 = ".  Leaves the model unchanged." + NL + "\t * @param uri The uri of the ";
  protected final String TEXT_44 = NL + "\t * @param model the Jena Model." + NL + "\t */" + NL + "\tpublic ";
  protected final String TEXT_45 = " get";
  protected final String TEXT_46 = "(String uri) throws JastorException {" + NL + "\t\treturn get";
  protected final String TEXT_47 = "(r(uri));" + NL + "\t}" + NL + "\t" + NL + "\t/**" + NL + "\t * Create a new instance of ";
  protected final String TEXT_48 = ".  Leaves the model unchanged." + NL + "\t * @param resource The resource of the ";
  protected final String TEXT_49 = NL + "\t * @param model the Jena Model." + NL + "\t */" + NL + "\tpublic static ";
  protected final String TEXT_50 = " get";
  protected final String TEXT_51 = "(Resource resource) throws JastorException {";
  protected final String TEXT_52 = NL + "\t\tString code = (resource.getModel().hashCode()*17 + ";
  protected final String TEXT_53 = ".class.hashCode()) + resource.toString();" + NL + "\t\t";
  protected final String TEXT_54 = " obj = (";
  protected final String TEXT_55 = ")objects.get(code);" + NL + "\t\tif (obj == null) {" + NL + "\t\t\tobj = ";
  protected final String TEXT_56 = ".get";
  protected final String TEXT_57 = "(resource);" + NL + "\t\t\tif (obj == null)" + NL + "\t\t\t\treturn null;" + NL + "\t\t\tobjects.put(code, obj);" + NL + "\t\t}" + NL + "\t\treturn obj;";
  protected final String TEXT_58 = NL + "\t\t";
  protected final String TEXT_59 = " obj = ";
  protected final String TEXT_60 = ".get";
  protected final String TEXT_61 = "(resource);" + NL + "\t\treturn obj;";
  protected final String TEXT_62 = NL + "\t}" + NL + "\t" + NL + "\t/**" + NL + "\t * Return an instance of ";
  protected final String TEXT_63 = " for every resource in the model with rdf:Type ";
  protected final String TEXT_64 = NL + "\t * @param model the Jena Model" + NL + "\t * @return an IIterableIterator of ";
  protected final String TEXT_65 = NL + "\t */" + NL + "\t@SuppressWarnings(\"unchecked\")" + NL + "\tpublic static IIterableIterator<";
  protected final String TEXT_66 = "> getAllDirect";
  protected final String TEXT_67 = "(final Model model) {" + NL + "\t\treturn new AMappingIterator<Statement,";
  protected final String TEXT_68 = ">(model.listStatements(null,RDF.type,";
  protected final String TEXT_69 = ".TYPE)) {" + NL + "\t\t\tpublic ";
  protected final String TEXT_70 = " map(Statement stmt) {" + NL + "\t\t\t  try {";
  protected final String TEXT_71 = NL + " \t\t\t    if (stmt.getSubject().hasProperty(RDF.type,";
  protected final String TEXT_72 = ".TYPE)) return get";
  protected final String TEXT_73 = "(stmt.getSubject());";
  protected final String TEXT_74 = NL + " \t\t\t    return get";
  protected final String TEXT_75 = "(stmt.getSubject());" + NL + " \t\t\t  } catch (JastorException ex) {" + NL + " \t\t\t  \tthrow new RuntimeException(ex);" + NL + " \t\t\t  }" + NL + "\t\t\t}" + NL + "\t\t};" + NL + "\t}" + NL + "\t" + NL + "\tpublic IIterableIterator<";
  protected final String TEXT_76 = "> getAllDirect";
  protected final String TEXT_77 = "() {" + NL + "\t\treturn getAllDirect";
  protected final String TEXT_78 = "(model);" + NL + "\t}" + NL + "" + NL + "\t/**" + NL + "\t * Return an instance of ";
  protected final String TEXT_79 = " for every resource in the model with rdf:Type ";
  protected final String TEXT_80 = " or any subClass" + NL + "\t * @param model the Jena Model" + NL + "\t * @return an IIterableIterator of ";
  protected final String TEXT_81 = NL + "\t */" + NL + "\t@SuppressWarnings(\"unchecked\")" + NL + "\tpublic static IIterableIterator<";
  protected final String TEXT_82 = "> getAll";
  protected final String TEXT_83 = "(final Model model) {" + NL + "\t\tIteratorIterator<";
  protected final String TEXT_84 = "> i = new IteratorIterator<";
  protected final String TEXT_85 = ">();";
  protected final String TEXT_86 = NL + "\t\ti.addIterator(new ALazyInitializingIterator<";
  protected final String TEXT_87 = ">() {" + NL + "\t\t\tpublic Iterator<";
  protected final String TEXT_88 = "> initialize() {" + NL + "\t\t    \treturn new AMappingIterator<Statement,";
  protected final String TEXT_89 = ">(model.listStatements(null,RDF.type,";
  protected final String TEXT_90 = ".TYPE)) {" + NL + "\t\t\t\t\tpublic ";
  protected final String TEXT_91 = " map(Statement stmt) {" + NL + "\t\t\t\t\t  try {" + NL + "\t\t\t\t\t    return get";
  protected final String TEXT_92 = "(stmt.getSubject());" + NL + "\t\t \t\t\t  } catch (JastorException ex) {" + NL + " \t\t\t\t\t  \tthrow new RuntimeException(ex);" + NL + " \t\t\t  \t\t  }" + NL + "\t\t\t\t\t}     \t\t" + NL + "\t\t     \t};" + NL + "\t    \t}" + NL + "\t\t});";
  protected final String TEXT_93 = NL + "\t\treturn new UniqueFilteringIterator<";
  protected final String TEXT_94 = ">((Iterator)i);" + NL + "\t}" + NL + "" + NL + "\tpublic IIterableIterator<";
  protected final String TEXT_95 = "> getAll";
  protected final String TEXT_96 = "() {" + NL + "\t\treturn getAll";
  protected final String TEXT_97 = "(model);" + NL + "\t}" + NL + "\t";
  protected final String TEXT_98 = NL + "\t" + NL + "\t/**" + NL + "\t * Returns an instance of an interface for the given Resource.  The return instance is guaranteed to " + NL + "\t * implement the most specific interface in *some* hierarchy in which the Resource participates.  The behavior" + NL + "\t * is unspecified for resources with RDF types from different hierarchies." + NL + "\t * @return an instance of Thing" + NL + "\t */" + NL + "\tpublic static ";
  protected final String TEXT_99 = " getThing(com.hp.hpl.jena.rdf.model.Resource res) throws JastorException {";
  protected final String TEXT_100 = NL + "\t\tif (res.hasProperty(RDF.type,res.getModel().getResource(\"";
  protected final String TEXT_101 = "\"))) {" + NL + "\t\t\treturn get";
  protected final String TEXT_102 = "(res);" + NL + "\t\t}";
  protected final String TEXT_103 = NL + "\t\treturn new ";
  protected final String TEXT_104 = "(res);" + NL + "\t}" + NL + "\t" + NL + "\t/**" + NL + "\t * Returns an instance of an interface for the given Resource URI.  The return instance is guaranteed to " + NL + "\t * implement the most specific interface in *some* hierarchy in which the Resource participates.  The behavior" + NL + "\t * is unspecified for resources with RDF types from different hierarchies." + NL + "\t * @return an instance of Thing" + NL + "\t */" + NL + "\tpublic static ";
  protected final String TEXT_105 = " getThing(String uri, com.hp.hpl.jena.rdf.model.Model model) throws JastorException {" + NL + "\t\treturn getThing(JenaHelper.r(model,uri));" + NL + "\t}" + NL + "" + NL + "\tpublic ";
  protected final String TEXT_106 = " getThing(String uri) throws JastorException {" + NL + "\t\treturn getThing(r(uri));" + NL + "\t}" + NL + "" + NL + "\t/**" + NL + "\t * Return a list of compatible interfaces for the given type.  Searches through all ontology classes" + NL + "\t * in the ";
  protected final String TEXT_107 = " ontology.  The list is sorted according to the topological sort" + NL + "\t * of the class hierarchy" + NL + "\t * @return a List of type java.lang.Class" + NL + "\t */" + NL + "\tpublic static java.util.List<Class> listCompatibleInterfaces (com.hp.hpl.jena.rdf.model.Resource type) {" + NL + "\t\tjava.util.List<Class> types = new java.util.ArrayList<Class>();";
  protected final String TEXT_108 = NL + "\t\tif (type.equals(";
  protected final String TEXT_109 = ".TYPE)) {" + NL + "\t\t\ttypes.add(";
  protected final String TEXT_110 = ".class);" + NL + "\t\t}";
  protected final String TEXT_111 = NL + "\t\treturn types;" + NL + "\t}" + NL + "}";

	public static final String copyright = "(C) Copyright IBM Corporation 2005  All Rights Reserved.";

	OntologyFileProvider fileProvider;

	public FactoryTemplate(OntologyFileProvider fileProvider) {
		this.fileProvider = fileProvider;
	}
	
	public FactoryTemplate() {
	}
	
	public OntologyFileProvider getFileProvider() {
		return fileProvider;
	}
	
	public void setFileProvider(OntologyFileProvider fileProvider) {
		this.fileProvider = fileProvider;
	}

	public String generate(Ontology ont)
  {
    final StringBuffer stringBuffer = new StringBuffer();
     //(C) Copyright IBM Corporation 2005  All Rights Reserved. 
    stringBuffer.append(TEXT_1);
     // author: Ben Szekely (<a href="mailto:bhszekel@us.ibm.com">bhszekel@us.ibm.com</a>) 
     String pkgstr = ont.getPackage(); 
     JastorContext ctx = ont.getContext(); 
    stringBuffer.append(TEXT_2);
    stringBuffer.append(pkgstr);
    stringBuffer.append(TEXT_3);
    stringBuffer.append(ont.getLocalName());
    stringBuffer.append(TEXT_4);
    stringBuffer.append(ont.getURI() );
    stringBuffer.append(TEXT_5);
     if (ont.getComment().listRDFSPropertyNames().length > 0) { 
    stringBuffer.append(TEXT_6);
     	String[] names = ont.getComment().listRDFSPropertyNames(); 
     	for (int i=0;i<names.length;i++) { 
    stringBuffer.append(TEXT_7);
    stringBuffer.append(names[i] + " : " + ont.getComment().getRDFSProperty(names[i]));
    stringBuffer.append(TEXT_8);
     	} 
     } 
    stringBuffer.append(TEXT_9);
     if (ont.getComment().listDCPropertyNames().length > 0) { 
    stringBuffer.append(TEXT_10);
     	String[] names = ont.getComment().listDCPropertyNames(); 
     	for (int i=0;i<names.length;i++) { 
    stringBuffer.append(TEXT_11);
    stringBuffer.append(names[i] + " : " + ont.getComment().getDCProperty(names[i]));
    stringBuffer.append(TEXT_12);
     	} 
     } 
    stringBuffer.append(TEXT_13);
     if (ont.getComment().getVersionInfo() != null) { 
    stringBuffer.append(TEXT_14);
    stringBuffer.append(ont.getComment().getVersionInfo());
     } 
    stringBuffer.append(TEXT_15);
    stringBuffer.append(ont.getFactoryClassname());
    stringBuffer.append(TEXT_16);
    stringBuffer.append(ctx.getThingFactory().getName());
    stringBuffer.append(TEXT_17);
    stringBuffer.append(ont.getFactoryClassname());
    stringBuffer.append(TEXT_18);
     for(Iterator iter = ont.getClasses().iterator(); iter.hasNext();) {
     OntologyClass oc = (OntologyClass)iter.next();
    stringBuffer.append(TEXT_19);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_20);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_21);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_22);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_23);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_24);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_25);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_26);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_27);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_28);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_29);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_30);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_31);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_32);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_33);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_34);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_35);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_36);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_37);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_38);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_39);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_40);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_41);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_42);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_43);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_44);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_45);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_46);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_47);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_48);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_49);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_50);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_51);
     	if (ctx.isGenerateCacheInFactory()) { 
    stringBuffer.append(TEXT_52);
    stringBuffer.append(oc.getInterfaceFullClassname());
    stringBuffer.append(TEXT_53);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_54);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_55);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_56);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_57);
     	} else { 
    stringBuffer.append(TEXT_58);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_59);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_60);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_61);
     	} 
    stringBuffer.append(TEXT_62);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_63);
    stringBuffer.append(oc.getURI());
    stringBuffer.append(TEXT_64);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_65);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_66);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_67);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_68);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_69);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_70);
     for(Iterator i = ont.getClassesSorted().iterator(); i.hasNext();) {
				   OntologyClass oc2 = (OntologyClass)i.next();
				   if(oc2.listAllExtensionClasses().contains(oc)) {
				
    stringBuffer.append(TEXT_71);
    stringBuffer.append(oc2.getInterfaceClassname());
    stringBuffer.append(TEXT_72);
    stringBuffer.append(oc2.getInterfaceClassname());
    stringBuffer.append(TEXT_73);
     } } 
    stringBuffer.append(TEXT_74);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_75);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_76);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_77);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_78);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_79);
    stringBuffer.append(oc.getURI());
    stringBuffer.append(TEXT_80);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_81);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_82);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_83);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_84);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_85);
     for(Iterator i = ont.getClassesSorted().iterator(); i.hasNext();) {
		   OntologyClass oc2 = (OntologyClass)i.next();
		   if(oc2.listAllExtensionClasses().contains(oc)) {
		
    stringBuffer.append(TEXT_86);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_87);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_88);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_89);
    stringBuffer.append(oc2.getInterfaceClassname());
    stringBuffer.append(TEXT_90);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_91);
    stringBuffer.append(oc2.getInterfaceClassname());
    stringBuffer.append(TEXT_92);
     } } 
    stringBuffer.append(TEXT_93);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_94);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_95);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_96);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_97);
     } 
    stringBuffer.append(TEXT_98);
    stringBuffer.append(ctx.getThingInterface().getName());
    stringBuffer.append(TEXT_99);
     for(Iterator iter = ont.getClassesSorted().iterator(); iter.hasNext();) {
     OntologyClass oc = (OntologyClass)iter.next();
    stringBuffer.append(TEXT_100);
    stringBuffer.append(oc.getURI());
    stringBuffer.append(TEXT_101);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_102);
     } 
    stringBuffer.append(TEXT_103);
    stringBuffer.append(ctx.getThingImpl().getName());
    stringBuffer.append(TEXT_104);
    stringBuffer.append(ctx.getThingInterface().getName());
    stringBuffer.append(TEXT_105);
    stringBuffer.append(ctx.getThingInterface().getName());
    stringBuffer.append(TEXT_106);
    stringBuffer.append(ont.getLocalName());
    stringBuffer.append(TEXT_107);
     for(Iterator iter = ont.getClassesSorted().iterator(); iter.hasNext();) {
     OntologyClass oc = (OntologyClass)iter.next();
    stringBuffer.append(TEXT_108);
    stringBuffer.append(oc.getInterfaceFullClassname());
    stringBuffer.append(TEXT_109);
    stringBuffer.append(oc.getInterfaceFullClassname());
    stringBuffer.append(TEXT_110);
     } 
    stringBuffer.append(TEXT_111);
    return stringBuffer.toString();
  }
}