package fi.seco.semweb.util.srcgen.templates;

import java.util.*;
import com.ibm.adtech.jastor.*;
import com.ibm.adtech.jastor.jet.*;
import com.ibm.adtech.jastor.inference.*;
import com.hp.hpl.jena.rdf.model.*;;

/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation 
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.opensource.org/licenses/cpl.php
 * 
 ******************************************************************************/

public class ImplementationTemplate implements OntologyClassTemplate {
  protected static String nl;
  public static synchronized ImplementationTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    ImplementationTemplate result = new ImplementationTemplate();
    nl = null;
    return result;
  }

  protected final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "";
  protected final String TEXT_2 = NL + NL + "package ";
  protected final String TEXT_3 = ";" + NL + "" + NL + "/*" + NL + "import com.hp.hpl.jena.datatypes.xsd.*;" + NL + "import com.hp.hpl.jena.datatypes.xsd.impl.*;" + NL + "*/" + NL + "import com.hp.hpl.jena.rdf.model.*;" + NL + "import com.hp.hpl.jena.vocabulary.RDF;" + NL + "import com.ibm.adtech.jastor.*;" + NL + "import com.ibm.adtech.jastor.util.*;" + NL + "" + NL + "" + NL + "/**" + NL + " * Implementation of {@link ";
  protected final String TEXT_4 = "}" + NL + " * Use the ";
  protected final String TEXT_5 = " to create instances of this class." + NL + " * <p>(URI: ";
  protected final String TEXT_6 = ")</p>" + NL + " * <br>" + NL + " */" + NL + "public class ";
  protected final String TEXT_7 = " extends ";
  protected final String TEXT_8 = " implements ";
  protected final String TEXT_9 = " {" + NL + "\t" + NL + "\tprivate static final long serialVersionUID = 1L;" + NL;
  protected final String TEXT_10 = NL + "\tprivate static com.hp.hpl.jena.rdf.model.Property ";
  protected final String TEXT_11 = "Property = ResourceFactory.createProperty(\"";
  protected final String TEXT_12 = "\");";
  protected final String TEXT_13 = NL + "\tprivate ";
  protected final String TEXT_14 = " ";
  protected final String TEXT_15 = ";";
  protected final String TEXT_16 = NL + "\tprivate java.util.ArrayList ";
  protected final String TEXT_17 = ";";
  protected final String TEXT_18 = NL + "\tprivate java.util.ArrayList ";
  protected final String TEXT_19 = ";";
  protected final String TEXT_20 = NL + NL + "\t";
  protected final String TEXT_21 = "(Resource resource) throws JastorException {" + NL + "\t\tsuper(resource);";
  protected final String TEXT_22 = NL + "\t\tsetupModelListener();";
  protected final String TEXT_23 = NL + "\t}     " + NL + "    \t" + NL + "\tstatic ";
  protected final String TEXT_24 = " get";
  protected final String TEXT_25 = "(Resource resource) throws JastorException {";
  protected final String TEXT_26 = NL + "\t\tif (!resource.getModel().contains(resource,RDF.type,";
  protected final String TEXT_27 = ".TYPE))" + NL + "\t\t\treturn null;";
  protected final String TEXT_28 = NL + "\t\treturn new ";
  protected final String TEXT_29 = "(resource);" + NL + "\t}" + NL + "\t    " + NL + "\tstatic ";
  protected final String TEXT_30 = " create";
  protected final String TEXT_31 = "(Resource resource) throws JastorException {" + NL + "\t\t";
  protected final String TEXT_32 = " impl = new ";
  protected final String TEXT_33 = "(resource);" + NL + "\t\t" + NL + "\t\tif (!impl.model.contains(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(impl.resource, RDF.type, ";
  protected final String TEXT_34 = ".TYPE)))" + NL + "\t\t\timpl.model.add(impl.resource, RDF.type, ";
  protected final String TEXT_35 = ".TYPE);" + NL + "\t\timpl.addSuperTypes();" + NL + "\t\timpl.addHasValueValues();" + NL + "\t\treturn impl;" + NL + "\t}" + NL + "\t" + NL + "\tvoid addSuperTypes() {";
  protected final String TEXT_36 = NL + "\t\tif (!model.contains(resource, RDF.type, ";
  protected final String TEXT_37 = ".TYPE))" + NL + "\t\t\tmodel.add(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(resource, RDF.type, ";
  protected final String TEXT_38 = ".TYPE));     ";
  protected final String TEXT_39 = NL + "\t}" + NL + "   " + NL + "\tvoid addHasValueValues() {";
  protected final String TEXT_40 = NL + "\t\tif (!model.contains(resource, ";
  protected final String TEXT_41 = "Property, model.getResource(\"";
  protected final String TEXT_42 = "\")))" + NL + "\t\t\tmodel.add(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(resource, ";
  protected final String TEXT_43 = "Property, model.getResource(\"";
  protected final String TEXT_44 = "\")));";
  protected final String TEXT_45 = NL + "\t\tif (!model.contains(resource, ";
  protected final String TEXT_46 = "Property, model.createTypedLiteral(\"";
  protected final String TEXT_47 = "\")))" + NL + "\t\t\tmodel.add(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(resource, ";
  protected final String TEXT_48 = "Property, model.createTypedLiteral(\"";
  protected final String TEXT_49 = "\")));";
  protected final String TEXT_50 = NL + "\t}" + NL + "    ";
  protected final String TEXT_51 = NL + "    private void setupModelListener() {";
  protected final String TEXT_52 = NL + "    \tlisteners = new java.util.ArrayList();";
  protected final String TEXT_53 = NL + "    \t";
  protected final String TEXT_54 = ".registerThing(this);" + NL + "    }";
  protected final String TEXT_55 = NL + NL + "\tpublic java.util.List<Statement> listStatements() {" + NL + "\t\tjava.util.List<Statement> list = new java.util.ArrayList<Statement>();" + NL + "\t\tStmtIterator it = null;";
  protected final String TEXT_56 = NL + "\t\tit = model.listStatements(resource,";
  protected final String TEXT_57 = "Property,(RDFNode)null);" + NL + "\t\twhile (it.hasNext()) {" + NL + "\t\t\tlist.add(it.nextStatement());" + NL + "\t\t}";
  protected final String TEXT_58 = NL + "\t\tit = model.listStatements(resource,RDF.type, ";
  protected final String TEXT_59 = ".TYPE);" + NL + "\t\twhile (it.hasNext()) {" + NL + "\t\t\tlist.add(it.nextStatement());" + NL + "\t\t}";
  protected final String TEXT_60 = NL + "\t\tit = model.listStatements(resource,RDF.type, ";
  protected final String TEXT_61 = ".TYPE);" + NL + "\t\twhile (it.hasNext()) {" + NL + "\t\t\tlist.add(it.nextStatement());" + NL + "\t\t}";
  protected final String TEXT_62 = NL + "\t\treturn list;" + NL + "\t}" + NL + "\t";
  protected final String TEXT_63 = NL + "\tpublic void clearCache() {";
  protected final String TEXT_64 = NL + "\t\t";
  protected final String TEXT_65 = " = null;";
  protected final String TEXT_66 = NL + "\t}";
  protected final String TEXT_67 = NL;
  protected final String TEXT_68 = NL + "\tpublic ";
  protected final String TEXT_69 = " get";
  protected final String TEXT_70 = "() throws JastorException {";
  protected final String TEXT_71 = NL + "\t\tif (";
  protected final String TEXT_72 = " != null)" + NL + "\t\t\treturn ";
  protected final String TEXT_73 = ";";
  protected final String TEXT_74 = NL + "\t\tcom.hp.hpl.jena.rdf.model.Statement stmt = model.getProperty(resource, ";
  protected final String TEXT_75 = "Property);" + NL + "\t\tif (stmt == null)" + NL + "\t\t\treturn null;" + NL + "\t\tif (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))" + NL + "\t\t\tthrow new JastorInvalidRDFNodeException(getURI() + \": ";
  protected final String TEXT_76 = " getProperty() in ";
  protected final String TEXT_77 = " model not Literal\", stmt.getObject());" + NL + "\t\tcom.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);";
  protected final String TEXT_78 = NL + "\t\t";
  protected final String TEXT_79 = " = literal;";
  protected final String TEXT_80 = NL + "\t\treturn literal;";
  protected final String TEXT_81 = NL + "\t\tObject obj = Util.fixLiteral(literal.getValue(),\"";
  protected final String TEXT_82 = "\");";
  protected final String TEXT_83 = NL + "\t\t";
  protected final String TEXT_84 = " = (";
  protected final String TEXT_85 = ")obj;" + NL + "\t\treturn ";
  protected final String TEXT_86 = ";";
  protected final String TEXT_87 = NL + "\t\treturn (";
  protected final String TEXT_88 = ")obj;";
  protected final String TEXT_89 = NL + "\t}" + NL + "\t" + NL + "\tpublic void set";
  protected final String TEXT_90 = "(";
  protected final String TEXT_91 = " ";
  protected final String TEXT_92 = ") throws JastorException {" + NL + "\t\tif (model.contains(resource,";
  protected final String TEXT_93 = "Property)) {" + NL + "\t\t\tmodel.removeAll(resource,";
  protected final String TEXT_94 = "Property,null);" + NL + "\t\t}";
  protected final String TEXT_95 = NL + "\t\tthis.";
  protected final String TEXT_96 = " = ";
  protected final String TEXT_97 = ";";
  protected final String TEXT_98 = "                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   " + NL + "\t\tif (";
  protected final String TEXT_99 = " != null) {";
  protected final String TEXT_100 = NL + "\t\t\tmodel.add(model.createStatement(resource,";
  protected final String TEXT_101 = "Property, ";
  protected final String TEXT_102 = "));";
  protected final String TEXT_103 = NL + "\t\t\tmodel.add(model.createStatement(resource,";
  protected final String TEXT_104 = "Property, model.createTypedLiteral(";
  protected final String TEXT_105 = ")));";
  protected final String TEXT_106 = NL + "\t\t}\t" + NL + "\t}";
  protected final String TEXT_107 = NL;
  protected final String TEXT_108 = NL + "\tprivate void init";
  protected final String TEXT_109 = "() throws JastorException {" + NL + "\t\t";
  protected final String TEXT_110 = " = new java.util.ArrayList();" + NL + "\t\t" + NL + "\t\tStmtIterator it = model.listStatements(resource, ";
  protected final String TEXT_111 = "Property, (RDFNode)null);" + NL + "\t\twhile(it.hasNext()) {" + NL + "\t\t\tcom.hp.hpl.jena.rdf.model.Statement stmt = (com.hp.hpl.jena.rdf.model.Statement)it.next();" + NL + "\t\t\tif (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))" + NL + "\t\t\t\tthrow new JastorInvalidRDFNodeException (getURI() + \": One of the ";
  protected final String TEXT_112 = " properties in ";
  protected final String TEXT_113 = " model not a Literal\", stmt.getObject());" + NL + "\t\t\tcom.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);";
  protected final String TEXT_114 = NL + "\t\t\t";
  protected final String TEXT_115 = ".add(literal);";
  protected final String TEXT_116 = NL + "\t\t\t";
  protected final String TEXT_117 = ".add(Util.fixLiteral(literal.getValue(),\"";
  protected final String TEXT_118 = "\"));";
  protected final String TEXT_119 = NL + "\t\t}" + NL + "\t}";
  protected final String TEXT_120 = NL + NL + "\tpublic java.util.Iterator get";
  protected final String TEXT_121 = "() throws JastorException {";
  protected final String TEXT_122 = NL + "\t\tif (";
  protected final String TEXT_123 = " == null)" + NL + "\t\t\tinit";
  protected final String TEXT_124 = "();" + NL + "\t\treturn new com.ibm.adtech.jastor.util.CachedPropertyIterator(";
  protected final String TEXT_125 = ",resource,";
  protected final String TEXT_126 = "Property,false);";
  protected final String TEXT_127 = NL + "\t\treturn new com.ibm.adtech.jastor.util.PropertyIterator(resource,";
  protected final String TEXT_128 = "Property,null) {" + NL + "\t\t\tpublic Object getPropertyValue(RDFNode value) {" + NL + "\t\t\t\tcom.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) value.as(com.hp.hpl.jena.rdf.model.Literal.class);";
  protected final String TEXT_129 = NL + "\t\t\treturn literal;";
  protected final String TEXT_130 = NL + "\t\t\treturn Util.fixLiteral(literal.getValue(),\"";
  protected final String TEXT_131 = "\");";
  protected final String TEXT_132 = NL + "\t\t\t}" + NL + "\t\t};";
  protected final String TEXT_133 = NL + "\t}" + NL + "" + NL + "\tpublic void add";
  protected final String TEXT_134 = "(";
  protected final String TEXT_135 = " ";
  protected final String TEXT_136 = ") throws JastorException {";
  protected final String TEXT_137 = NL + "\t\tif (this.";
  protected final String TEXT_138 = " == null)" + NL + "\t\t\tinit";
  protected final String TEXT_139 = "();" + NL + "\t\tif (this.";
  protected final String TEXT_140 = ".contains(";
  protected final String TEXT_141 = "))" + NL + "\t\t\treturn;";
  protected final String TEXT_142 = NL + "\t\tif (model.contains(resource, ";
  protected final String TEXT_143 = "Property, model.createTypedLiteral(";
  protected final String TEXT_144 = ")))" + NL + "\t\t\treturn;";
  protected final String TEXT_145 = NL + "\t\tthis.";
  protected final String TEXT_146 = ".add(";
  protected final String TEXT_147 = ");";
  protected final String TEXT_148 = NL + "\t\tmodel.add(resource, ";
  protected final String TEXT_149 = "Property, ";
  protected final String TEXT_150 = ");";
  protected final String TEXT_151 = NL + "\t\tmodel.add(resource, ";
  protected final String TEXT_152 = "Property, model.createTypedLiteral(";
  protected final String TEXT_153 = "));";
  protected final String TEXT_154 = NL + "\t}" + NL + "\t" + NL + "\tpublic void remove";
  protected final String TEXT_155 = "(";
  protected final String TEXT_156 = " ";
  protected final String TEXT_157 = ") throws JastorException {";
  protected final String TEXT_158 = NL + "\t\tif (this.";
  protected final String TEXT_159 = " == null)" + NL + "\t\t\tinit";
  protected final String TEXT_160 = "();" + NL + "\t\tif (!this.";
  protected final String TEXT_161 = ".contains(";
  protected final String TEXT_162 = "))" + NL + "\t\t\treturn;";
  protected final String TEXT_163 = NL + "\t\tif (!model.contains(resource, ";
  protected final String TEXT_164 = "Property, model.createTypedLiteral(";
  protected final String TEXT_165 = ")))" + NL + "\t\t\treturn;";
  protected final String TEXT_166 = NL + "\t\tthis.";
  protected final String TEXT_167 = ".remove(";
  protected final String TEXT_168 = ");";
  protected final String TEXT_169 = NL + "\t\tmodel.removeAll(resource, ";
  protected final String TEXT_170 = "Property, model.createTypedLiteral(";
  protected final String TEXT_171 = "));" + NL + "\t}" + NL;
  protected final String TEXT_172 = NL + "\tpublic ";
  protected final String TEXT_173 = " get";
  protected final String TEXT_174 = "() throws JastorException {";
  protected final String TEXT_175 = NL + "\t\tif (";
  protected final String TEXT_176 = " != null)" + NL + "\t\t\treturn ";
  protected final String TEXT_177 = ";";
  protected final String TEXT_178 = NL + "\t\tcom.hp.hpl.jena.rdf.model.Statement stmt = model.getProperty(resource, ";
  protected final String TEXT_179 = "Property);" + NL + "\t\tif (stmt == null)" + NL + "\t\t\treturn null;" + NL + "\t\tif (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))" + NL + "\t\t\tthrow new JastorInvalidRDFNodeException(getURI() + \": ";
  protected final String TEXT_180 = " getProperty() in ";
  protected final String TEXT_181 = " model not Resource\", stmt.getObject());" + NL + "\t\tcom.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);";
  protected final String TEXT_182 = NL + "\t\tif (!model.contains(resource,RDF.type,";
  protected final String TEXT_183 = ".TYPE))" + NL + "\t\t\treturn null;";
  protected final String TEXT_184 = NL + "\t\t";
  protected final String TEXT_185 = " = ";
  protected final String TEXT_186 = ".get";
  protected final String TEXT_187 = "(resource);" + NL + "\t\treturn ";
  protected final String TEXT_188 = ";";
  protected final String TEXT_189 = NL + "\t\treturn ";
  protected final String TEXT_190 = ".get";
  protected final String TEXT_191 = "(resource);";
  protected final String TEXT_192 = NL + "\t}" + NL + "" + NL + "\tpublic void set";
  protected final String TEXT_193 = "(";
  protected final String TEXT_194 = " ";
  protected final String TEXT_195 = ") throws JastorException {" + NL + "\t\tif (model.contains(resource,";
  protected final String TEXT_196 = "Property)) {" + NL + "\t\t\tmodel.removeAll(resource,";
  protected final String TEXT_197 = "Property,null);" + NL + "\t\t}";
  protected final String TEXT_198 = NL + "\t\tthis.";
  protected final String TEXT_199 = " = ";
  protected final String TEXT_200 = ";";
  protected final String TEXT_201 = NL + "\t\tif (";
  protected final String TEXT_202 = " != null) {" + NL + "\t\t\tmodel.add(model.createStatement(resource,";
  protected final String TEXT_203 = "Property, ";
  protected final String TEXT_204 = ".getResource()));" + NL + "\t\t}\t\t\t" + NL + "\t}" + NL + "\t\t" + NL + "\tpublic ";
  protected final String TEXT_205 = " set";
  protected final String TEXT_206 = "() throws JastorException {" + NL + "\t\tif (model.contains(resource,";
  protected final String TEXT_207 = "Property)) {" + NL + "\t\t\tmodel.removeAll(resource,";
  protected final String TEXT_208 = "Property,null);" + NL + "\t\t}" + NL + "\t\t";
  protected final String TEXT_209 = " ";
  protected final String TEXT_210 = " = ";
  protected final String TEXT_211 = ".create";
  protected final String TEXT_212 = "(model.createResource());";
  protected final String TEXT_213 = NL + "\t\tthis.";
  protected final String TEXT_214 = " = ";
  protected final String TEXT_215 = ";";
  protected final String TEXT_216 = NL + "\t\tmodel.add(model.createStatement(resource,";
  protected final String TEXT_217 = "Property, ";
  protected final String TEXT_218 = ".getResource()));" + NL + "\t\treturn ";
  protected final String TEXT_219 = ";" + NL + "\t}" + NL + "\t" + NL + "\tpublic ";
  protected final String TEXT_220 = " set";
  protected final String TEXT_221 = "(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {";
  protected final String TEXT_222 = NL + "\t\tif (!model.contains(resource,RDF.type,";
  protected final String TEXT_223 = ".TYPE))" + NL + "\t\t\tthrow new JastorException(\"Resource \" + resource + \" not of type \" + ";
  protected final String TEXT_224 = ".TYPE);";
  protected final String TEXT_225 = NL + "\t\tif (model.contains(resource,";
  protected final String TEXT_226 = "Property)) {" + NL + "\t\t\tmodel.removeAll(resource,";
  protected final String TEXT_227 = "Property,null);" + NL + "\t\t}" + NL + "\t\t";
  protected final String TEXT_228 = " ";
  protected final String TEXT_229 = " = ";
  protected final String TEXT_230 = ".get";
  protected final String TEXT_231 = "(resource);";
  protected final String TEXT_232 = NL + "\t\tthis.";
  protected final String TEXT_233 = " = ";
  protected final String TEXT_234 = ";";
  protected final String TEXT_235 = NL + "\t\tmodel.add(model.createStatement(resource,";
  protected final String TEXT_236 = "Property, ";
  protected final String TEXT_237 = ".getResource()));" + NL + "\t\treturn ";
  protected final String TEXT_238 = ";" + NL + "\t}" + NL + "\t";
  protected final String TEXT_239 = NL + "\tprivate void init";
  protected final String TEXT_240 = "() throws JastorException {" + NL + "\t\tthis.";
  protected final String TEXT_241 = " = new java.util.ArrayList();" + NL + "\t\tStmtIterator it = model.listStatements(resource, ";
  protected final String TEXT_242 = "Property, (RDFNode)null);" + NL + "\t\twhile(it.hasNext()) {" + NL + "\t\t\tcom.hp.hpl.jena.rdf.model.Statement stmt = (com.hp.hpl.jena.rdf.model.Statement)it.next();" + NL + "\t\t\tif (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))" + NL + "\t\t\t\tthrow new JastorInvalidRDFNodeException (getURI() + \": One of the ";
  protected final String TEXT_243 = " properties in ";
  protected final String TEXT_244 = " model not a Resource\", stmt.getObject());" + NL + "\t\t\tcom.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);";
  protected final String TEXT_245 = NL + "\t\t\tif (model.contains(resource,RDF.type,";
  protected final String TEXT_246 = ".TYPE)) {";
  protected final String TEXT_247 = NL + "\t\t\tif (true) { // don't check resource type if the property range is Resource";
  protected final String TEXT_248 = NL + "\t\t\t\t";
  protected final String TEXT_249 = " ";
  protected final String TEXT_250 = " = ";
  protected final String TEXT_251 = ".get";
  protected final String TEXT_252 = "(resource);" + NL + "\t\t\t\tthis.";
  protected final String TEXT_253 = ".add(";
  protected final String TEXT_254 = ");" + NL + "\t\t\t}" + NL + "\t\t}" + NL + "\t}";
  protected final String TEXT_255 = NL + NL + "\tpublic java.util.Iterator get";
  protected final String TEXT_256 = "() throws JastorException {";
  protected final String TEXT_257 = NL + "\t\tif (";
  protected final String TEXT_258 = " == null)" + NL + "\t\t\tinit";
  protected final String TEXT_259 = "();" + NL + "\t\treturn new com.ibm.adtech.jastor.util.CachedPropertyIterator(";
  protected final String TEXT_260 = ",resource,";
  protected final String TEXT_261 = "Property,true);";
  protected final String TEXT_262 = NL + "\t\treturn new com.ibm.adtech.jastor.util.PropertyIterator(resource,";
  protected final String TEXT_263 = "Property,";
  protected final String TEXT_264 = ".TYPE) {\t";
  protected final String TEXT_265 = NL + "\t\treturn new com.ibm.adtech.jastor.util.PropertyIterator(resource,";
  protected final String TEXT_266 = "Property,null) {";
  protected final String TEXT_267 = NL + "\t\t\tpublic Object getPropertyValue(RDFNode value) {" + NL + "\t\t\t\tcom.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) value.as(com.hp.hpl.jena.rdf.model.Resource.class);" + NL + "\t\t\t\ttry {" + NL + "\t\t\t\t\treturn ";
  protected final String TEXT_268 = ".get";
  protected final String TEXT_269 = "(resource);" + NL + "\t\t\t\t} catch (JastorException e) {" + NL + "\t\t\t\t\tthrow new java.util.NoSuchElementException(e.getMessage());" + NL + "\t\t\t\t}" + NL + "\t\t\t}" + NL + "\t\t\t};";
  protected final String TEXT_270 = NL + "\t}" + NL + "" + NL + "\tpublic void add";
  protected final String TEXT_271 = "(";
  protected final String TEXT_272 = " ";
  protected final String TEXT_273 = ") throws JastorException {";
  protected final String TEXT_274 = NL + "\t\tif (this.";
  protected final String TEXT_275 = " == null)" + NL + "\t\t\tinit";
  protected final String TEXT_276 = "();" + NL + "\t\tif (this.";
  protected final String TEXT_277 = ".contains(";
  protected final String TEXT_278 = ")) {" + NL + "\t\t\tthis.";
  protected final String TEXT_279 = ".remove(";
  protected final String TEXT_280 = ");" + NL + "\t\t\tthis.";
  protected final String TEXT_281 = ".add(";
  protected final String TEXT_282 = ");" + NL + "\t\t\treturn;" + NL + "\t\t}" + NL + "\t\tthis.";
  protected final String TEXT_283 = ".add(";
  protected final String TEXT_284 = ");";
  protected final String TEXT_285 = NL + "\t\tmodel.add(model.createStatement(resource,";
  protected final String TEXT_286 = "Property,";
  protected final String TEXT_287 = ".getResource()));" + NL + "\t}" + NL + "\t" + NL + "\tpublic ";
  protected final String TEXT_288 = " add";
  protected final String TEXT_289 = "() throws JastorException {" + NL + "\t\t";
  protected final String TEXT_290 = " ";
  protected final String TEXT_291 = " = ";
  protected final String TEXT_292 = ".create";
  protected final String TEXT_293 = "(model.createResource());";
  protected final String TEXT_294 = NL + "\t\tif (this.";
  protected final String TEXT_295 = " == null)" + NL + "\t\t\tinit";
  protected final String TEXT_296 = "();" + NL + "\t\tthis.";
  protected final String TEXT_297 = ".add(";
  protected final String TEXT_298 = ");";
  protected final String TEXT_299 = NL + "\t\tmodel.add(model.createStatement(resource,";
  protected final String TEXT_300 = "Property,";
  protected final String TEXT_301 = ".getResource()));" + NL + "\t\treturn ";
  protected final String TEXT_302 = ";" + NL + "\t}" + NL + "\t" + NL + "\tpublic ";
  protected final String TEXT_303 = " add";
  protected final String TEXT_304 = "(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {";
  protected final String TEXT_305 = NL + "\t\tif (!model.contains(resource,RDF.type,";
  protected final String TEXT_306 = ".TYPE))" + NL + "\t\t\tthrow new JastorException(\"Resource \" + resource + \" not of type \" + ";
  protected final String TEXT_307 = ".TYPE);";
  protected final String TEXT_308 = NL + "\t\t";
  protected final String TEXT_309 = " ";
  protected final String TEXT_310 = " = ";
  protected final String TEXT_311 = ".get";
  protected final String TEXT_312 = "(resource);";
  protected final String TEXT_313 = NL + "\t\tif (this.";
  protected final String TEXT_314 = " == null)" + NL + "\t\t\tinit";
  protected final String TEXT_315 = "();" + NL + "\t\tif (this.";
  protected final String TEXT_316 = ".contains(";
  protected final String TEXT_317 = "))" + NL + "\t\t\treturn ";
  protected final String TEXT_318 = ";" + NL + "\t\tthis.";
  protected final String TEXT_319 = ".add(";
  protected final String TEXT_320 = ");";
  protected final String TEXT_321 = NL + "\t\tmodel.add(model.createStatement(resource,";
  protected final String TEXT_322 = "Property,";
  protected final String TEXT_323 = ".getResource()));" + NL + "\t\treturn ";
  protected final String TEXT_324 = ";" + NL + "\t}" + NL + "\t" + NL + "\tpublic void remove";
  protected final String TEXT_325 = "(";
  protected final String TEXT_326 = " ";
  protected final String TEXT_327 = ") throws JastorException {";
  protected final String TEXT_328 = NL + "\t\tif (this.";
  protected final String TEXT_329 = " == null)" + NL + "\t\t\tinit";
  protected final String TEXT_330 = "();" + NL + "\t\tif (!this.";
  protected final String TEXT_331 = ".contains(";
  protected final String TEXT_332 = "))" + NL + "\t\t\treturn;";
  protected final String TEXT_333 = NL + "\t\tif (!model.contains(resource, ";
  protected final String TEXT_334 = "Property, ";
  protected final String TEXT_335 = ".getResource()))" + NL + "\t\t\treturn;";
  protected final String TEXT_336 = NL + "\t\tthis.";
  protected final String TEXT_337 = ".remove(";
  protected final String TEXT_338 = ");";
  protected final String TEXT_339 = NL + "\t\tmodel.removeAll(resource, ";
  protected final String TEXT_340 = "Property, ";
  protected final String TEXT_341 = ".getResource());" + NL + "\t}" + NL + "\t\t";
  protected final String TEXT_342 = " ";
  protected final String TEXT_343 = " " + NL;
  protected final String TEXT_344 = NL + NL + "\tprivate java.util.ArrayList listeners;" + NL + "\t" + NL + "\tpublic void registerListener(ThingListener listener) {" + NL + "\t\tif (!(listener instanceof ";
  protected final String TEXT_345 = "Listener))" + NL + "\t\t\tthrow new IllegalArgumentException(\"ThingListener must be instance of ";
  protected final String TEXT_346 = "\"); " + NL + "\t\tif (listeners == null)" + NL + "\t\t\tsetupModelListener();" + NL + "\t\tif(!this.listeners.contains(listener)){" + NL + "\t\t\tthis.listeners.add((";
  protected final String TEXT_347 = ")listener);" + NL + "\t\t}" + NL + "\t}" + NL + "\t" + NL + "\tpublic void unregisterListener(ThingListener listener) {" + NL + "\t\tif (!(listener instanceof ";
  protected final String TEXT_348 = "Listener))" + NL + "\t\t\tthrow new IllegalArgumentException(\"ThingListener must be instance of ";
  protected final String TEXT_349 = "\"); " + NL + "\t\tif (listeners == null)" + NL + "\t\t\treturn;" + NL + "\t\tif (this.listeners.contains(listener)){" + NL + "\t\t\tlisteners.remove(listener);" + NL + "\t\t}" + NL + "\t}" + NL;
  protected final String TEXT_350 = NL;
  protected final String TEXT_351 = NL + NL + "\t" + NL + "\t\tpublic void addedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {" + NL;
  protected final String TEXT_352 = NL + "\t\t\tif (stmt.getPredicate().equals(";
  protected final String TEXT_353 = "Property)) {";
  protected final String TEXT_354 = NL + "\t\t\t\tif (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))" + NL + "\t\t\t\t\treturn;" + NL + "\t\t\t\tcom.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);";
  protected final String TEXT_355 = NL + "\t\t\t\t";
  protected final String TEXT_356 = " = literal;";
  protected final String TEXT_357 = NL + "\t\t\t\t";
  protected final String TEXT_358 = " = (";
  protected final String TEXT_359 = ")Util.fixLiteral(literal.getValue(),\"";
  protected final String TEXT_360 = "\");";
  protected final String TEXT_361 = NL + "\t\t\t\tif (listeners != null) {" + NL + "\t\t\t\t\tjava.util.ArrayList consumers;" + NL + "\t\t\t\t\tsynchronized (listeners) {" + NL + "\t\t\t\t\t\tconsumers = (java.util.ArrayList) listeners.clone();" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t\tfor(java.util.Iterator iter=consumers.iterator();iter.hasNext();){" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_362 = "Listener listener=(";
  protected final String TEXT_363 = "Listener)iter.next();" + NL + "\t\t\t\t\t\tlistener.";
  protected final String TEXT_364 = "Changed(";
  protected final String TEXT_365 = ".this);" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t}";
  protected final String TEXT_366 = NL + "\t\t\t\tif (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))" + NL + "\t\t\t\t\treturn;" + NL + "\t\t\t\tcom.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);" + NL + "\t\t\t\t//Object obj = literal.getValue();";
  protected final String TEXT_367 = NL + "\t\t\t\tif (";
  protected final String TEXT_368 = " == null)" + NL + "\t\t\t\t\ttry {" + NL + "\t\t\t\t\t\tinit";
  protected final String TEXT_369 = "();" + NL + "\t\t\t\t\t} catch (JastorException e) {" + NL + "\t\t\t\t\t\te.printStackTrace();" + NL + "\t\t\t\t\t\treturn;" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\tif (!";
  protected final String TEXT_370 = ".contains(literal))" + NL + "\t\t\t\t\t";
  protected final String TEXT_371 = ".add(literal);";
  protected final String TEXT_372 = NL + "\t\t\t\tif (listeners != null) {" + NL + "\t\t\t\t\tjava.util.ArrayList consumersFor";
  protected final String TEXT_373 = ";" + NL + "\t\t\t\t\tsynchronized (listeners) {" + NL + "\t\t\t\t\t\tconsumersFor";
  protected final String TEXT_374 = " = (java.util.ArrayList) listeners.clone();" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t\tfor(java.util.Iterator iter=consumersFor";
  protected final String TEXT_375 = ".iterator();iter.hasNext();){" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_376 = "Listener listener=(";
  protected final String TEXT_377 = "Listener)iter.next();" + NL + "\t\t\t\t\t\tlistener.";
  protected final String TEXT_378 = "Added(";
  protected final String TEXT_379 = ".this,literal);" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t}";
  protected final String TEXT_380 = NL + "\t\t\t\tObject obj = Util.fixLiteral(literal.getValue(),\"";
  protected final String TEXT_381 = "\");";
  protected final String TEXT_382 = NL + "\t\t\t\tif (";
  protected final String TEXT_383 = " == null) {" + NL + "\t\t\t\t\ttry {" + NL + "\t\t\t\t\t\tinit";
  protected final String TEXT_384 = "();" + NL + "\t\t\t\t\t} catch (JastorException e) {" + NL + "\t\t\t\t\t\te.printStackTrace();" + NL + "\t\t\t\t\t\treturn;" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t}" + NL + "\t\t\t\tif (!";
  protected final String TEXT_385 = ".contains(obj))" + NL + "\t\t\t\t\t";
  protected final String TEXT_386 = ".add(obj);";
  protected final String TEXT_387 = NL + "\t\t\t\tjava.util.ArrayList consumersFor";
  protected final String TEXT_388 = ";" + NL + "\t\t\t\tif (listeners != null) {" + NL + "\t\t\t\t\tsynchronized (listeners) {" + NL + "\t\t\t\t\t\tconsumersFor";
  protected final String TEXT_389 = " = (java.util.ArrayList) listeners.clone();" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t\tfor(java.util.Iterator iter=consumersFor";
  protected final String TEXT_390 = ".iterator();iter.hasNext();){" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_391 = "Listener listener=(";
  protected final String TEXT_392 = "Listener)iter.next();" + NL + "\t\t\t\t\t\tlistener.";
  protected final String TEXT_393 = "Added(";
  protected final String TEXT_394 = ".this,(";
  protected final String TEXT_395 = ")obj);" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t}";
  protected final String TEXT_396 = NL + "\t\t\t\tif (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))" + NL + "\t\t\t\t\treturn;" + NL + "\t\t\t\tcom.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);";
  protected final String TEXT_397 = NL + "\t\t\t\t";
  protected final String TEXT_398 = " = null;";
  protected final String TEXT_399 = NL + "\t\t\t\tif (model.contains(resource,RDF.type,";
  protected final String TEXT_400 = ".TYPE)) {";
  protected final String TEXT_401 = NL + "\t\t\t\tif (true) { // don't check resource type if the property range is Resource";
  protected final String TEXT_402 = NL + "\t\t\t\t\ttry {" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_403 = " = ";
  protected final String TEXT_404 = ".get";
  protected final String TEXT_405 = "(resource);" + NL + "\t\t\t\t\t} catch (JastorException e) {" + NL + "\t\t\t\t\t\t//e.printStackTrace();" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t}";
  protected final String TEXT_406 = NL + "\t\t\t\tif (listeners != null) {" + NL + "\t\t\t\t\tjava.util.ArrayList consumers;" + NL + "\t\t\t\t\tsynchronized (listeners) {" + NL + "\t\t\t\t\t\tconsumers = (java.util.ArrayList) listeners.clone();" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t\tfor(java.util.Iterator iter=consumers.iterator();iter.hasNext();){" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_407 = "Listener listener=(";
  protected final String TEXT_408 = "Listener)iter.next();" + NL + "\t\t\t\t\t\tlistener.";
  protected final String TEXT_409 = "Changed(";
  protected final String TEXT_410 = ".this);" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t}";
  protected final String TEXT_411 = NL + "\t\t\t\tif (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))" + NL + "\t\t\t\t\treturn;" + NL + "\t\t\t\tcom.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);";
  protected final String TEXT_412 = NL + "\t\t\t\tif (model.contains(resource,RDF.type,";
  protected final String TEXT_413 = ".TYPE)) {";
  protected final String TEXT_414 = NL + "\t\t\t\tif (true) { // don't check resource type if the property range is Resource";
  protected final String TEXT_415 = NL + "\t\t\t\t\t";
  protected final String TEXT_416 = " _";
  protected final String TEXT_417 = " = null;" + NL + "\t\t\t\t\ttry {" + NL + "\t\t\t\t\t\t_";
  protected final String TEXT_418 = " = ";
  protected final String TEXT_419 = ".get";
  protected final String TEXT_420 = "(resource);" + NL + "\t\t\t\t\t} catch (JastorException e) {" + NL + "\t\t\t\t\t\t//e.printStackTrace();" + NL + "\t\t\t\t\t}";
  protected final String TEXT_421 = NL + "\t\t\t\t\tif (";
  protected final String TEXT_422 = " == null) {" + NL + "\t\t\t\t\t\ttry {" + NL + "\t\t\t\t\t\t\tinit";
  protected final String TEXT_423 = "();" + NL + "\t\t\t\t\t\t} catch (JastorException e) {" + NL + "\t\t\t\t\t\t\te.printStackTrace();" + NL + "\t\t\t\t\t\t\treturn;" + NL + "\t\t\t\t\t\t}" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t\tif (!";
  protected final String TEXT_424 = ".contains(_";
  protected final String TEXT_425 = "))" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_426 = ".add(_";
  protected final String TEXT_427 = ");";
  protected final String TEXT_428 = NL + "\t\t\t\t\tif (listeners != null) {" + NL + "\t\t\t\t\t\tjava.util.ArrayList consumersFor";
  protected final String TEXT_429 = ";" + NL + "\t\t\t\t\t\tsynchronized (listeners) {" + NL + "\t\t\t\t\t\t\tconsumersFor";
  protected final String TEXT_430 = " = (java.util.ArrayList) listeners.clone();" + NL + "\t\t\t\t\t\t}" + NL + "\t\t\t\t\t\tfor(java.util.Iterator iter=consumersFor";
  protected final String TEXT_431 = ".iterator();iter.hasNext();){" + NL + "\t\t\t\t\t\t\t";
  protected final String TEXT_432 = "Listener listener=(";
  protected final String TEXT_433 = "Listener)iter.next();" + NL + "\t\t\t\t\t\t\tlistener.";
  protected final String TEXT_434 = "Added(";
  protected final String TEXT_435 = ".this,_";
  protected final String TEXT_436 = ");" + NL + "\t\t\t\t\t\t}" + NL + "\t\t\t\t\t}";
  protected final String TEXT_437 = NL + "\t\t\t\t}";
  protected final String TEXT_438 = NL + "\t\t\t\treturn;" + NL + "\t\t\t}";
  protected final String TEXT_439 = NL + "\t\t}" + NL + "\t\t" + NL + "\t\tpublic void removedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {" + NL + "//\t\t\tif (!stmt.getSubject().equals(resource))" + NL + "//\t\t\t\treturn;";
  protected final String TEXT_440 = NL + "\t\t\tif (stmt.getPredicate().equals(";
  protected final String TEXT_441 = "Property)) {";
  protected final String TEXT_442 = NL + "\t\t\t\tif (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))" + NL + "\t\t\t\t\treturn;" + NL + "\t\t\t\tcom.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);" + NL + "\t\t\t\t//Object obj = literal.getValue();";
  protected final String TEXT_443 = NL + "\t\t\t\tif (";
  protected final String TEXT_444 = " != null && ";
  protected final String TEXT_445 = ".equals(literal))" + NL + "\t\t\t\t\t";
  protected final String TEXT_446 = " = null;";
  protected final String TEXT_447 = NL + "\t\t\t\tObject obj = Util.fixLiteral(literal.getValue(),\"";
  protected final String TEXT_448 = "\");" + NL + "\t\t\t\tif (";
  protected final String TEXT_449 = " != null && ";
  protected final String TEXT_450 = ".equals(obj))" + NL + "\t\t\t\t\t";
  protected final String TEXT_451 = " = null;";
  protected final String TEXT_452 = NL + "\t\t\t\tif (listeners != null) {" + NL + "\t\t\t\t\tjava.util.ArrayList consumers;" + NL + "\t\t\t\t\tsynchronized (listeners) {" + NL + "\t\t\t\t\t\tconsumers = (java.util.ArrayList) listeners.clone();" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t\tfor(java.util.Iterator iter=consumers.iterator();iter.hasNext();){" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_453 = "Listener listener=(";
  protected final String TEXT_454 = "Listener)iter.next();" + NL + "\t\t\t\t\t\tlistener.";
  protected final String TEXT_455 = "Changed(";
  protected final String TEXT_456 = ".this);" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t}";
  protected final String TEXT_457 = NL + "\t\t\t\tif (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))" + NL + "\t\t\t\t\treturn;" + NL + "\t\t\t\tcom.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);" + NL + "\t\t\t\t//Object obj = literal.getValue();";
  protected final String TEXT_458 = NL + "\t\t\t\tif (";
  protected final String TEXT_459 = " != null) {" + NL + "\t\t\t\t\tif (";
  protected final String TEXT_460 = ".contains(literal))" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_461 = ".remove(literal);" + NL + "\t\t\t\t}";
  protected final String TEXT_462 = NL + "\t\t\t\tif (listeners != null) {" + NL + "\t\t\t\t\tjava.util.ArrayList consumersFor";
  protected final String TEXT_463 = ";" + NL + "\t\t\t\t\tsynchronized (listeners) {" + NL + "\t\t\t\t\t\tconsumersFor";
  protected final String TEXT_464 = " = (java.util.ArrayList) listeners.clone();" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t\tfor(java.util.Iterator iter=consumersFor";
  protected final String TEXT_465 = ".iterator();iter.hasNext();){" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_466 = "Listener listener=(";
  protected final String TEXT_467 = "Listener)iter.next();" + NL + "\t\t\t\t\t\tlistener.";
  protected final String TEXT_468 = "Removed(";
  protected final String TEXT_469 = ".this,literal);" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t}";
  protected final String TEXT_470 = NL + "\t\t\t\tObject obj = Util.fixLiteral(literal.getValue(),\"";
  protected final String TEXT_471 = "\");";
  protected final String TEXT_472 = NL + "\t\t\t\tif (";
  protected final String TEXT_473 = " != null) {" + NL + "\t\t\t\t\tif (";
  protected final String TEXT_474 = ".contains(obj))" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_475 = ".remove(obj);" + NL + "\t\t\t\t}";
  protected final String TEXT_476 = NL + "\t\t\t\tif (listeners != null) {" + NL + "\t\t\t\t\tjava.util.ArrayList consumers;" + NL + "\t\t\t\t\tsynchronized (listeners) {" + NL + "\t\t\t\t\t\tconsumers = (java.util.ArrayList) listeners.clone();" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t\tfor(java.util.Iterator iter=consumers.iterator();iter.hasNext();){" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_477 = "Listener listener=(";
  protected final String TEXT_478 = "Listener)iter.next();" + NL + "\t\t\t\t\t\tlistener.";
  protected final String TEXT_479 = "Removed(";
  protected final String TEXT_480 = ".this,(";
  protected final String TEXT_481 = ")obj);" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t}";
  protected final String TEXT_482 = NL + "\t\t\t\tif (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))" + NL + "\t\t\t\t\treturn;" + NL + "\t\t\t\tcom.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);";
  protected final String TEXT_483 = NL + "\t\t\t\t\tif (";
  protected final String TEXT_484 = " != null && ";
  protected final String TEXT_485 = ".getResource().equals(resource))" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_486 = " = null;\t\t\t\t";
  protected final String TEXT_487 = NL + "\t\t\t\tif (listeners != null) {" + NL + "\t\t\t\t\tjava.util.ArrayList consumers;" + NL + "\t\t\t\t\tsynchronized (listeners) {" + NL + "\t\t\t\t\t\tconsumers = (java.util.ArrayList) listeners.clone();" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t\tfor(java.util.Iterator iter=consumers.iterator();iter.hasNext();){" + NL + "\t\t\t\t\t\t";
  protected final String TEXT_488 = "Listener listener=(";
  protected final String TEXT_489 = "Listener)iter.next();" + NL + "\t\t\t\t\t\tlistener.";
  protected final String TEXT_490 = "Changed(";
  protected final String TEXT_491 = ".this);" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t}";
  protected final String TEXT_492 = NL + "\t\t\t\tif (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))" + NL + "\t\t\t\t\treturn;" + NL + "\t\t\t\tcom.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);";
  protected final String TEXT_493 = NL + "\t\t\t\tif (model.contains(resource,RDF.type,";
  protected final String TEXT_494 = ".TYPE)) {";
  protected final String TEXT_495 = NL + "\t\t\t\tif (true) { // don't check resource type if the property range is Resource";
  protected final String TEXT_496 = NL + "\t\t\t\t\t";
  protected final String TEXT_497 = " _";
  protected final String TEXT_498 = " = null;" + NL + "\t\t\t\t\tif (";
  protected final String TEXT_499 = " != null) {" + NL + "\t\t\t\t\t\tboolean found = false;" + NL + "\t\t\t\t\t\tfor (int i=0;i<";
  protected final String TEXT_500 = ".size();i++) {" + NL + "\t\t\t\t\t\t\t";
  protected final String TEXT_501 = " __item = (";
  protected final String TEXT_502 = ") ";
  protected final String TEXT_503 = ".get(i);" + NL + "\t\t\t\t\t\t\tif (__item.getResource().equals(resource)) {" + NL + "\t\t\t\t\t\t\t\tfound = true;" + NL + "\t\t\t\t\t\t\t\t_";
  protected final String TEXT_504 = " = __item;" + NL + "\t\t\t\t\t\t\t\tbreak;" + NL + "\t\t\t\t\t\t\t}" + NL + "\t\t\t\t\t\t}" + NL + "\t\t\t\t\t\tif (found)" + NL + "\t\t\t\t\t\t\t";
  protected final String TEXT_505 = ".remove(_";
  protected final String TEXT_506 = ");" + NL + "\t\t\t\t\t\telse {" + NL + "\t\t\t\t\t\t\ttry {" + NL + "\t\t\t\t\t\t\t\t_";
  protected final String TEXT_507 = " = ";
  protected final String TEXT_508 = ".get";
  protected final String TEXT_509 = "(resource);" + NL + "\t\t\t\t\t\t\t} catch (JastorException e) {" + NL + "\t\t\t\t\t\t\t}" + NL + "\t\t\t\t\t\t}" + NL + "\t\t\t\t\t} else {" + NL + "\t\t\t\t\t\ttry {" + NL + "\t\t\t\t\t\t\t_";
  protected final String TEXT_510 = " = ";
  protected final String TEXT_511 = ".get";
  protected final String TEXT_512 = "(resource);" + NL + "\t\t\t\t\t\t} catch (JastorException e) {" + NL + "\t\t\t\t\t\t}" + NL + "\t\t\t\t\t}";
  protected final String TEXT_513 = NL + "\t\t\t\t\t";
  protected final String TEXT_514 = " _";
  protected final String TEXT_515 = " = null;" + NL + "\t\t\t\t\ttry {" + NL + "\t\t\t\t\t\t_";
  protected final String TEXT_516 = " = ";
  protected final String TEXT_517 = ".get";
  protected final String TEXT_518 = "(resource);" + NL + "\t\t\t\t\t} catch (JastorException e) {" + NL + "\t\t\t\t\t}";
  protected final String TEXT_519 = NL + "\t\t\t\t\tif (listeners != null) {" + NL + "\t\t\t\t\t\tjava.util.ArrayList consumersFor";
  protected final String TEXT_520 = ";" + NL + "\t\t\t\t\t\tsynchronized (listeners) {" + NL + "\t\t\t\t\t\t\tconsumersFor";
  protected final String TEXT_521 = " = (java.util.ArrayList) listeners.clone();" + NL + "\t\t\t\t\t\t}" + NL + "\t\t\t\t\t\tfor(java.util.Iterator iter=consumersFor";
  protected final String TEXT_522 = ".iterator();iter.hasNext();){" + NL + "\t\t\t\t\t\t\t";
  protected final String TEXT_523 = "Listener listener=(";
  protected final String TEXT_524 = "Listener)iter.next();" + NL + "\t\t\t\t\t\t\tlistener.";
  protected final String TEXT_525 = "Removed(";
  protected final String TEXT_526 = ".this,_";
  protected final String TEXT_527 = ");" + NL + "\t\t\t\t\t\t}" + NL + "\t\t\t\t\t}";
  protected final String TEXT_528 = NL + "\t\t\t\t}";
  protected final String TEXT_529 = NL + "\t\t\t\treturn;" + NL + "\t\t\t}";
  protected final String TEXT_530 = NL + "\t\t}" + NL + "" + NL + "\t//}" + NL + "\t";
  protected final String TEXT_531 = NL + NL + NL + "}";

	public static final String copyright = "(C) Copyright IBM Corporation 2005  All Rights Reserved.";
	
	OntologyClassFileProvider fileProvider;

	public ImplementationTemplate(OntologyClassFileProvider fileProvider) {
		this.fileProvider = fileProvider;
	}
	
	public ImplementationTemplate() {
	}
	
	public OntologyClassFileProvider getFileProvider() {
		return fileProvider;
	}	
	
	public void setFileProvider(OntologyClassFileProvider fileProvider) {
		this.fileProvider = fileProvider;
	}

	public String generate(OntologyClass oc)
  {
    final StringBuffer stringBuffer = new StringBuffer();
     //(C) Copyright IBM Corporation 2005  All Rights Reserved. 
    stringBuffer.append(TEXT_1);
     // author: Ben Szekely (<a href="mailto:bhszekel@us.ibm.com">bhszekel@us.ibm.com</a>) 
     JastorContext ctx = oc.getContext(); 
    stringBuffer.append(TEXT_2);
    stringBuffer.append(oc.getPackageName());
    stringBuffer.append(TEXT_3);
    stringBuffer.append(oc.getInterfaceFullClassname());
    stringBuffer.append(TEXT_4);
    stringBuffer.append(oc.getFactoryFullClassname());
    stringBuffer.append(TEXT_5);
    stringBuffer.append(oc.getURI() );
    stringBuffer.append(TEXT_6);
    stringBuffer.append(oc.getImplClassname());
    stringBuffer.append(TEXT_7);
    stringBuffer.append(ctx.getThingImpl().getName());
    stringBuffer.append(TEXT_8);
    stringBuffer.append(oc.getInterfaceFullClassname());
    stringBuffer.append(TEXT_9);
     for (java.util.Iterator iter = oc.listProperties(true).iterator(); iter.hasNext();) {
     		OntologyProperty prop = (OntologyProperty)iter.next(); 
     // have to add the properties here to so we have no ambiguity with multiple inheritance 
    stringBuffer.append(TEXT_10);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_11);
    stringBuffer.append(prop.getURI());
    stringBuffer.append(TEXT_12);
     	if (ctx.isGeneratePropertyCache()) { 
           if (prop.isSingleValued()) { 
    				for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
        			Resource res = (Resource)iter2.next();
    stringBuffer.append(TEXT_13);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_14);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_15);
       			} 
           } 
           if (prop.isMultiValued() && prop.isDatatypeProperty()) { 
    				for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
        			Resource res = (Resource)iter2.next();
    stringBuffer.append(TEXT_16);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_17);
       			} 
           } 
           if (prop.isMultiValued() && prop.isObjectProperty()) { 
    				for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
        			Resource res = (Resource)iter2.next();
    stringBuffer.append(TEXT_18);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_19);
       			} 
           } 
     	} 
     } 
    stringBuffer.append(TEXT_20);
    stringBuffer.append(oc.getImplClassname());
    stringBuffer.append(TEXT_21);
     if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_22);
     } 
    stringBuffer.append(TEXT_23);
    stringBuffer.append(oc.getImplClassname());
    stringBuffer.append(TEXT_24);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_25);
     if (ctx.isUseStrictTypeChecking()) { 
    stringBuffer.append(TEXT_26);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_27);
     } 
    stringBuffer.append(TEXT_28);
    stringBuffer.append(oc.getImplClassname());
    stringBuffer.append(TEXT_29);
    stringBuffer.append(oc.getImplClassname());
    stringBuffer.append(TEXT_30);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_31);
    stringBuffer.append(oc.getImplClassname());
    stringBuffer.append(TEXT_32);
    stringBuffer.append(oc.getImplClassname());
    stringBuffer.append(TEXT_33);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_34);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_35);
    	java.util.Iterator superit = oc.listAllExtensionClasses().iterator(); 
    	while (superit.hasNext()) { 
    		OntologyClass ocl = (OntologyClass)superit.next(); 
    stringBuffer.append(TEXT_36);
    stringBuffer.append(ocl.getInterfaceFullClassname());
    stringBuffer.append(TEXT_37);
    stringBuffer.append(ocl.getInterfaceFullClassname());
    stringBuffer.append(TEXT_38);
    	} 
    stringBuffer.append(TEXT_39);
     	for (java.util.Iterator iter = oc.listProperties(true).iterator(); iter.hasNext();) {
     		OntologyProperty prop = (OntologyProperty)iter.next(); 
    			List list = prop.getHasValueValues(); 
    			for (int i=0;i<list.size();i++) { 
    				RDFNode node = (RDFNode)list.get(i); 
    				if (prop.isObjectProperty()) { 
    stringBuffer.append(TEXT_40);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_41);
    stringBuffer.append(node);
    stringBuffer.append(TEXT_42);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_43);
    stringBuffer.append(node);
    stringBuffer.append(TEXT_44);
    				} else { 
    stringBuffer.append(TEXT_45);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_46);
    stringBuffer.append(node);
    stringBuffer.append(TEXT_47);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_48);
    stringBuffer.append(node);
    stringBuffer.append(TEXT_49);
    				} 
    			} 
    		} 
    stringBuffer.append(TEXT_50);
     if (ctx.isGeneratePropertyCache() || ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_51);
    		if (ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_52);
    		} 
    stringBuffer.append(TEXT_53);
    stringBuffer.append(oc.getFactoryFullClassname());
    stringBuffer.append(TEXT_54);
     } 
    stringBuffer.append(TEXT_55);
     for (java.util.Iterator iter = oc.listProperties(true).iterator(); iter.hasNext();) {
     	OntologyProperty prop = (OntologyProperty)iter.next(); 
    stringBuffer.append(TEXT_56);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_57);
     } 
    stringBuffer.append(TEXT_58);
    stringBuffer.append(oc.getInterfaceFullClassname());
    stringBuffer.append(TEXT_59);
    	for (java.util.Iterator iter = oc.listAllExtensionClasses().iterator(); iter.hasNext();) { 
    		OntologyClass ocl = (OntologyClass)iter.next(); 
    stringBuffer.append(TEXT_60);
    stringBuffer.append(ocl.getInterfaceFullClassname());
    stringBuffer.append(TEXT_61);
    	} 
    stringBuffer.append(TEXT_62);
     if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_63);
     	for (java.util.Iterator iter = oc.listProperties(true).iterator(); iter.hasNext();) {
     	OntologyProperty prop = (OntologyProperty)iter.next(); 
    		for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
              Resource res = (Resource)iter2.next();
    stringBuffer.append(TEXT_64);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_65);
    		} 
     	} 
    stringBuffer.append(TEXT_66);
     } 
    stringBuffer.append(TEXT_67);
     for (java.util.Iterator iter = oc.listProperties(true).iterator(); iter.hasNext();) {
     	OntologyProperty prop = (OntologyProperty)iter.next(); 
    		if (prop.isSingleValued() && prop.isDatatypeProperty()) { 
    			for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
              Resource res = (Resource)iter2.next();
    stringBuffer.append(TEXT_68);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_69);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_70);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_71);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_72);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_73);
     			} 
    stringBuffer.append(TEXT_74);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_75);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_76);
    stringBuffer.append(oc.getInterfaceFullClassname());
    stringBuffer.append(TEXT_77);
     			if (prop.getReturnType(res).equals("com.hp.hpl.jena.rdf.model.Literal")) { 
     				if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_78);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_79);
    				} 
    stringBuffer.append(TEXT_80);
     			} else { 
    stringBuffer.append(TEXT_81);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_82);
     				if (ctx.isGeneratePropertyCache())  { 
    stringBuffer.append(TEXT_83);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_84);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_85);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_86);
    				} else { 
    stringBuffer.append(TEXT_87);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_88);
    				} 
     			} 
    stringBuffer.append(TEXT_89);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_90);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_91);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_92);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_93);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_94);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_95);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_96);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_97);
     			} 
    stringBuffer.append(TEXT_98);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_99);
     			if (prop.getReturnType(res).equals("com.hp.hpl.jena.rdf.model.Literal")) {
    stringBuffer.append(TEXT_100);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_101);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_102);
     			} else { 
    stringBuffer.append(TEXT_103);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_104);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_105);
    				} 
    stringBuffer.append(TEXT_106);
           } // end allRanges 
       } // end single-data 
    stringBuffer.append(TEXT_107);
    	  if (prop.isMultiValued() && prop.isDatatypeProperty()) { 
    			for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
              Resource res = (Resource)iter2.next();
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_108);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_109);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_110);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_111);
    stringBuffer.append(prop.getURI());
    stringBuffer.append(TEXT_112);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_113);
     				if (prop.getReturnType(res).equals("com.hp.hpl.jena.rdf.model.Literal")) { 
    stringBuffer.append(TEXT_114);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_115);
                 } else { 
    stringBuffer.append(TEXT_116);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_117);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_118);
                 } 
    stringBuffer.append(TEXT_119);
     			}  
    stringBuffer.append(TEXT_120);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_121);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_122);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_123);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_124);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_125);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_126);
     			} else { 
    stringBuffer.append(TEXT_127);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_128);
     				if (prop.getReturnType(res).equals("com.hp.hpl.jena.rdf.model.Literal")) { 
    stringBuffer.append(TEXT_129);
                  } else { 
    stringBuffer.append(TEXT_130);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_131);
    			    } 
    stringBuffer.append(TEXT_132);
              } 
    stringBuffer.append(TEXT_133);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_134);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_135);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_136);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_137);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_138);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_139);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_140);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_141);
    				} 
    stringBuffer.append(TEXT_142);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_143);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_144);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_145);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_146);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_147);
    				} 
     			if (prop.getReturnType(res).equals("com.hp.hpl.jena.rdf.model.Literal")) {
    stringBuffer.append(TEXT_148);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_149);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_150);
     			} else { 
    stringBuffer.append(TEXT_151);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_152);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_153);
    			} 
    stringBuffer.append(TEXT_154);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_155);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_156);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_157);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_158);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_159);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_160);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_161);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_162);
    				} 
    stringBuffer.append(TEXT_163);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_164);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_165);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_166);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_167);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_168);
    				} 
    stringBuffer.append(TEXT_169);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_170);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_171);
       		} 
       } 
    	 if (prop.isSingleValued() && prop.isObjectProperty()) { 
    			for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
              Resource res = (Resource)iter2.next();
    stringBuffer.append(TEXT_172);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_173);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_174);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_175);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_176);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_177);
     			} 
    stringBuffer.append(TEXT_178);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_179);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_180);
    stringBuffer.append(oc.getInterfaceFullClassname());
    stringBuffer.append(TEXT_181);
              if (res != OntologyProperty.DEFAULT_RANGE && !prop.getRangeOntologyClass(res).getURI().equals(com.hp.hpl.jena.vocabulary.RDFS.Resource.getURI())) { 
    stringBuffer.append(TEXT_182);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceFullClassname());
    stringBuffer.append(TEXT_183);
    			} 
     			if (ctx.isGeneratePropertyCache())  { 
    stringBuffer.append(TEXT_184);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_185);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_186);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_187);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_188);
    			} else { 
    stringBuffer.append(TEXT_189);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_190);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_191);
    			} 
    stringBuffer.append(TEXT_192);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_193);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_194);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_195);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_196);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_197);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_198);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_199);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_200);
     			} 
    stringBuffer.append(TEXT_201);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_202);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_203);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_204);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_205);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_206);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_207);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_208);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_209);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_210);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_211);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_212);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_213);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_214);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_215);
     			} 
    stringBuffer.append(TEXT_216);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_217);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_218);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_219);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_220);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_221);
     			if (ctx.isUseStrictTypeChecking() && !prop.getRangeOntologyClass(res).getURI().equals(com.hp.hpl.jena.vocabulary.RDFS.Resource.getURI())) { 
    stringBuffer.append(TEXT_222);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceFullClassname());
    stringBuffer.append(TEXT_223);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceFullClassname());
    stringBuffer.append(TEXT_224);
     			} 
    stringBuffer.append(TEXT_225);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_226);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_227);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_228);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_229);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_230);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_231);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_232);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_233);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_234);
     			} 
    stringBuffer.append(TEXT_235);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_236);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_237);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_238);
           } 
      } 
    	 if (prop.isMultiValued() && prop.isObjectProperty()) { 
    			for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
              Resource res = (Resource)iter2.next();
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_239);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_240);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_241);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_242);
    stringBuffer.append(prop.getURI());
    stringBuffer.append(TEXT_243);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_244);
              	if (res != OntologyProperty.DEFAULT_RANGE && !prop.getRangeOntologyClass(res).getURI().equals(com.hp.hpl.jena.vocabulary.RDFS.Resource.getURI())) { 
    stringBuffer.append(TEXT_245);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceFullClassname());
    stringBuffer.append(TEXT_246);
    				} else { 
    stringBuffer.append(TEXT_247);
    			    } 
    stringBuffer.append(TEXT_248);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_249);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_250);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_251);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_252);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_253);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_254);
     			} 
    stringBuffer.append(TEXT_255);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_256);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_257);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_258);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_259);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_260);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_261);
     			} else { 
    				if (res != OntologyProperty.DEFAULT_RANGE) { 
    stringBuffer.append(TEXT_262);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_263);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceFullClassname());
    stringBuffer.append(TEXT_264);
    				} else  { 
    stringBuffer.append(TEXT_265);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_266);
    		        } 
    stringBuffer.append(TEXT_267);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_268);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_269);
    			} 
    stringBuffer.append(TEXT_270);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_271);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_272);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_273);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_274);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_275);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_276);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_277);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_278);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_279);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_280);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_281);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_282);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_283);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_284);
     			} 
    stringBuffer.append(TEXT_285);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_286);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_287);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_288);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_289);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_290);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_291);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_292);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_293);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_294);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_295);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_296);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_297);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_298);
    				} 
    stringBuffer.append(TEXT_299);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_300);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_301);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_302);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_303);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_304);
     			if (ctx.isUseStrictTypeChecking() && !prop.getRangeOntologyClass(res).getURI().equals(com.hp.hpl.jena.vocabulary.RDFS.Resource.getURI())) { 
    stringBuffer.append(TEXT_305);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceFullClassname());
    stringBuffer.append(TEXT_306);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceFullClassname());
    stringBuffer.append(TEXT_307);
     			} 
    stringBuffer.append(TEXT_308);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_309);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_310);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_311);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_312);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_313);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_314);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_315);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_316);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_317);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_318);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_319);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_320);
    				} 
    stringBuffer.append(TEXT_321);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_322);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_323);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_324);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_325);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_326);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_327);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_328);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_329);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_330);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_331);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_332);
    				} 
    stringBuffer.append(TEXT_333);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_334);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_335);
     			if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_336);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_337);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_338);
    				} 
    stringBuffer.append(TEXT_339);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_340);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_341);
        } // end alt return types 
    stringBuffer.append(TEXT_342);
      }  // end mulitvalued-object 
     } // end all props
    stringBuffer.append(TEXT_343);
     if (ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_344);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_345);
    stringBuffer.append(oc.getListenerClassname());
    stringBuffer.append(TEXT_346);
    stringBuffer.append(oc.getListenerClassname());
    stringBuffer.append(TEXT_347);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_348);
    stringBuffer.append(oc.getListenerClassname());
    stringBuffer.append(TEXT_349);
     } 
    stringBuffer.append(TEXT_350);
     if (ctx.isGeneratePropertyCache() || ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_351);
     	for (java.util.Iterator iter = oc.listProperties(true).iterator(); iter.hasNext();) { 
     		OntologyProperty prop = (OntologyProperty)iter.next(); 
    stringBuffer.append(TEXT_352);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_353);
    			if (prop.isSingleValued() && prop.isDatatypeProperty()) { 
    stringBuffer.append(TEXT_354);
    				if (ctx.isGeneratePropertyCache()) { 
    					for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
              		Resource res = (Resource)iter2.next();
     					if (prop.getReturnType(res).equals("com.hp.hpl.jena.rdf.model.Literal")) { 
    stringBuffer.append(TEXT_355);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_356);
    						}  else {
    stringBuffer.append(TEXT_357);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_358);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_359);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_360);
    						} 
    					} 
    				} 
    				if (ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_361);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_362);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_363);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_364);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_365);
    				} 
    			} 
    			if (prop.isMultiValued() && prop.isDatatypeProperty()) { 
    stringBuffer.append(TEXT_366);
    				for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
              	Resource res = (Resource)iter2.next();
     				if (prop.getReturnType(res).equals("com.hp.hpl.jena.rdf.model.Literal")) { 
     					if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_367);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_368);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_369);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_370);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_371);
    					} 
    						if (ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_372);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_373);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_374);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_375);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_376);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_377);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_378);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_379);
    						} 
    				}  else {
    stringBuffer.append(TEXT_380);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_381);
     					if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_382);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_383);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_384);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_385);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_386);
    					} 
    						if (ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_387);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_388);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_389);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_390);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_391);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_392);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_393);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_394);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_395);
    						} 
    					} 
    				} 
    			} 
    			if (prop.isSingleValued() && prop.isObjectProperty()) { 
    stringBuffer.append(TEXT_396);
    				if (ctx.isGeneratePropertyCache()) { 
    					for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
              			Resource res = (Resource)iter2.next(); 
    stringBuffer.append(TEXT_397);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_398);
              			if (res != OntologyProperty.DEFAULT_RANGE && !prop.getRangeOntologyClass(res).getURI().equals(com.hp.hpl.jena.vocabulary.RDFS.Resource.getURI())) { 
    stringBuffer.append(TEXT_399);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceFullClassname());
    stringBuffer.append(TEXT_400);
    						} else { 
    stringBuffer.append(TEXT_401);
    			    		} 
    stringBuffer.append(TEXT_402);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_403);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_404);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_405);
    					} 
    				} 
    				if (ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_406);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_407);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_408);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_409);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_410);
    				} 
    			} 
    			if (prop.isMultiValued() && prop.isObjectProperty()) { 
    stringBuffer.append(TEXT_411);
    				for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
    					Resource res = (Resource)iter2.next(); 
              		if (res != OntologyProperty.DEFAULT_RANGE && !prop.getRangeOntologyClass(res).getURI().equals(com.hp.hpl.jena.vocabulary.RDFS.Resource.getURI())) { 
    stringBuffer.append(TEXT_412);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceFullClassname());
    stringBuffer.append(TEXT_413);
    					} else { 
    stringBuffer.append(TEXT_414);
    			   		} 
    stringBuffer.append(TEXT_415);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_416);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_417);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_418);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_419);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_420);
     					if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_421);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_422);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_423);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_424);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_425);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_426);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_427);
    					} 
    					if (ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_428);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_429);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_430);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_431);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_432);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_433);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_434);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_435);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_436);
    					} 
    stringBuffer.append(TEXT_437);
    				} 
    			} 
    stringBuffer.append(TEXT_438);
    	} 
    stringBuffer.append(TEXT_439);
     	for (java.util.Iterator iter = oc.listProperties(true).iterator(); iter.hasNext();) { 
     		OntologyProperty prop = (OntologyProperty)iter.next(); 
    stringBuffer.append(TEXT_440);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_441);
    			if (prop.isSingleValued() && prop.isDatatypeProperty()) { 
    stringBuffer.append(TEXT_442);
    				if (ctx.isGeneratePropertyCache()) { 
    					for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
              		Resource res = (Resource)iter2.next();
     					if (prop.getReturnType(res).equals("com.hp.hpl.jena.rdf.model.Literal")) { 
    stringBuffer.append(TEXT_443);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_444);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_445);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_446);
    						}  else {
    stringBuffer.append(TEXT_447);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_448);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_449);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_450);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_451);
    						} 
    					} 
    				} 
    				if (ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_452);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_453);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_454);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_455);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_456);
    				} 
    			} 
    			if (prop.isMultiValued() && prop.isDatatypeProperty()) { 
    stringBuffer.append(TEXT_457);
    				for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
              	Resource res = (Resource)iter2.next();
     				if (prop.getReturnType(res).equals("com.hp.hpl.jena.rdf.model.Literal")) { 
     					if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_458);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_459);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_460);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_461);
    						} 
    						if (ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_462);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_463);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_464);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_465);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_466);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_467);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_468);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_469);
    						} 
    					} else {
    stringBuffer.append(TEXT_470);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_471);
     				if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_472);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_473);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_474);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_475);
    				} 
    						if (ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_476);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_477);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_478);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_479);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_480);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_481);
    						} 
    					} 
    				} 
    			} 
    			if (prop.isSingleValued() && prop.isObjectProperty()) { 
    stringBuffer.append(TEXT_482);
    				if (ctx.isGeneratePropertyCache()) { 
    					for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
              		Resource res = (Resource)iter2.next(); 
    stringBuffer.append(TEXT_483);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_484);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_485);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_486);
    					} 
    				} 
    				if (ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_487);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_488);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_489);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_490);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_491);
    				} 
    			} 
    			if (prop.isMultiValued() && prop.isObjectProperty()) { 
    stringBuffer.append(TEXT_492);
    				for (java.util.Iterator iter2 = prop.listAllRanges();iter2.hasNext();) { 
    					Resource res = (Resource)iter2.next(); 
              		if (res != OntologyProperty.DEFAULT_RANGE && !prop.getRangeOntologyClass(res).getURI().equals(com.hp.hpl.jena.vocabulary.RDFS.Resource.getURI())) { 
    stringBuffer.append(TEXT_493);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceFullClassname());
    stringBuffer.append(TEXT_494);
    					} else { 
    stringBuffer.append(TEXT_495);
    			   		} 
     					if (ctx.isGeneratePropertyCache()) { 
    stringBuffer.append(TEXT_496);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_497);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_498);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_499);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_500);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_501);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_502);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_503);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_504);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_505);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_506);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_507);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_508);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_509);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_510);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_511);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_512);
    					} else { 
    stringBuffer.append(TEXT_513);
    stringBuffer.append(prop.getReturnType(res));
    stringBuffer.append(TEXT_514);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_515);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_516);
    stringBuffer.append(prop.getRangeOntologyClass(res).getFactoryFullClassname());
    stringBuffer.append(TEXT_517);
    stringBuffer.append(prop.getRangeOntologyClass(res).getInterfaceClassname());
    stringBuffer.append(TEXT_518);
    					} 
    					if (ctx.isGenerateListeners()) { 
    stringBuffer.append(TEXT_519);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_520);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_521);
    stringBuffer.append(prop.getPropertyCapped(res));
    stringBuffer.append(TEXT_522);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_523);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_524);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_525);
    stringBuffer.append(oc.getImplFullClassname());
    stringBuffer.append(TEXT_526);
    stringBuffer.append(prop.getPropertyName(res));
    stringBuffer.append(TEXT_527);
    					} 
    stringBuffer.append(TEXT_528);
    				} 
    			} 
    stringBuffer.append(TEXT_529);
    	} 
    stringBuffer.append(TEXT_530);
     } 
    stringBuffer.append(TEXT_531);
    return stringBuffer.toString();
  }
}