package fi.seco.semweb.view.js.vbsearch;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import fi.seco.semweb.service.search.ItemSearchController;
import fi.seco.semweb.service.search.ResultSet;
import fi.seco.semweb.service.search.query.IQueryPart;
import fi.seco.semweb.service.search.query.IntersectionQuery;

public class JSSearchController {

	private ItemSearchController control;
	private Collection<IJSView> views = new ArrayList<IJSView>();

	public JSSearchController() { }

	public JSSearchController(ItemSearchController control) {
		this.control=control;
	}

	public void setItemSearchController(ItemSearchController control) {
		this.control=control;
	}

	public ResultSet getCurrentResultSet() {
		IntersectionQuery ic = new IntersectionQuery();
		for (IJSView v : views) {
			IQueryPart p = v.getCurrentConstraints();
			if (p!=null) ic.addToIntersection(p);
		}
		if (ic.getParts().isEmpty()) return null;
		return control.getResultSet(ic);
	}

	public void registerView(IJSView view) {
		this.views.add(view);
	}

	public void removeView(IJSView view) {
		this.views.remove(view);
	}

	public Map<String, Object> getViewUpdates() {
		Map<String,Object> update = new HashMap<String,Object>();
		for (IJSView v : views)
			update.put(v.getWidgetId(),v.getViewUpdate());
		return update;
	}
}
